package de.heinerkuecker.asm_improved;

/**
 * Dieses Tupel enthaelt eine Methode
 * {@link AsmMethodInfo}, bei welcher alle
 * Typen (Return-Typ und Parameter-Typ)
 * bound-resolved wurden und die
 * originale Methode.
 * 
 * @author Heiner K&uuml;cker
 */
public class AsmBoundResolvedMethodAndOriginalMethodTuple
{
	public final AsmMethodInfo boundResolvedMethod;
	
	public final AsmMethodInfo originalMethod;

	/**
	 * Konstruktor.
	 * 
	 * @param boundResolvedMethod
	 * @param originalMethod
	 */
	public AsmBoundResolvedMethodAndOriginalMethodTuple(
			AsmMethodInfo boundResolvedMethod ,
			AsmMethodInfo originalMethod )
	{
		this.boundResolvedMethod = boundResolvedMethod;
		this.originalMethod = originalMethod;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public String toString() {
		return this.getClass().getSimpleName() + "[" +
				"boundResolvedMethod=" + this.boundResolvedMethod + ", " +
				"originalMethod=" + this.originalMethod + 
				"]";
	}

}