package de.heinerkuecker.asm_improved;

import java.util.Map;
import java.util.TreeMap;

import de.heinerkuecker.asm_improved.type.AsmType;
import de.heinerkuecker.asm_improved.type.generics.param.AsmExtendsTypeParam;

/**
 * Parser f&uuml;r Type-Informationen,
 * mit und ohne Generics,
 * anhand der von
 * <a href="asm.ow2.org">ASM</a> gelieferten
 * Strings.
 * 
 * TODO kann diese Klasse weg ?
 * 
 * @author Heiner K&uuml;cker
 */
final class AsmFieldDescAndSignatureParser
{
	/**
	 * Konstruktor private,
	 * Instanziieren verboten,
	 * Util-Klasse.
	 */
	private AsmFieldDescAndSignatureParser()
	{
		super();
	}

	public static AsmType parseFieldDescriptionAndSignature(
			final String desc ,
			final String signature ,
			final Map<String, ? extends AsmExtendsTypeParam> extendsTypeParamMap ,
			final ClasspathFiles classpathFiles ,
			final TreeMap<String, ? extends String> innerClassFileNameToDotSeparatedNameMap ,
			final FilteredForNonStaticAndSortedForOuterNameLengthReverseAsmDomInnerClasses innerClasses )
	{
		final String strToParse =
				AsmDescAndSignatureParserUtil.determineDescOrSignatureAndRemoveExceptions(
						desc ,
						signature );

		final AsmType fieldType =
				AsmDescAndSignatureParserUtil.parseTypeStr(
						strToParse ,
						extendsTypeParamMap ,
						classpathFiles ,
						innerClassFileNameToDotSeparatedNameMap ,
						innerClasses );

		//if ( fieldType instanceof TmpAsmMemberClassOfTypevar )
		//	// in temporrem Objekt vermerkte Typ-Variable und relativer Typ-Name mit Typ-Argumenten zum Ausflsen der Typ-Information anhand des desc-Parameters (Typ-Informationen ohne Generics)
		//{
		//	/* Bei der Notation innerer oder
		//	 * geschachtelter Klassen relativ
		//	 * zu einer Typ-Variable wird
		//	 * aus dem Parameter desc die
		//	 * aufgelste Klassen-Information
		//	 * eines eventuellen intersection
		//	 * bounds ausgelesen.
		//	 */
		//	final TmpAsmMemberClassOfTypevar tmpAsmMemberClassOfTypevar =
		//			(TmpAsmMemberClassOfTypevar) fieldType;
		//
		//	final AsmClassType noGenericsAsmType =
		//			(AsmClassType) AsmDescAndSignatureParserUtil.parseTypeStr(
		//					//typeStr
		//					AsmDescAndSignatureParserUtil.removeExceptions( desc ) ,
		//					extendsTypeParamMap ,
		//					classpathFiles ,
		//					innerClassFileNameToDotSeparatedNameMap );
		//
		//	final AsmClassType classType =
		//			new AsmClassType(
		//					noGenericsAsmType.fqn ,
		//					//typeArgs
		//					tmpAsmMemberClassOfTypevar.typeArgs );
		//
		//	//return new AsmMemberClassOfTypevar(
		//	//		//outerOrEnclosingTypevar
		//	//		tmpAsmMemberClassOfTypevar.outerOrEnclosingTypevar ,
		//	//		//relativName
		//	//		tmpAsmMemberClassOfTypevar.relativName ,
		//	//		classType );
		//	return classType;
		//}
		//else if ( fieldType instanceof AsmMemberClassType &&
		//		( (AsmMemberClassType) fieldType ).isMemberOfTypevar() )
		//{
		//	final AsmMemberClassType tmpMemberClassType = (AsmMemberClassType) fieldType;
		//
		//	throw new RuntimeException( "nicht fertig" );
		//}

		// TODO diese Korrektur berall rein
		//if ( (fieldType instanceof AsmClassOrMemberClassType ) &&
		//		( ! innerClasses.isEmpty() ) )
		//{
		//	return AsmMemberClassTypeCorrector.correctMemberClassType(
		//			(AsmClassOrMemberClassType) fieldType ,
		//			innerClasses );
		//}
		
		return fieldType;
	}
	
}
