package de.heinerkuecker.asm_improved;

import java.util.Collections;
import java.util.HashMap;
import java.util.Map;

import de.heinerkuecker.asm_improved.type.AsmType;
import de.heinerkuecker.asm_improved.type.generics.param.AsmExtendsTypeParam;
import de.heinerkuecker.asm_improved.type.generics.param.AsmAbstractTypeParam;
import de.heinerkuecker.asm_improved.util.ImmutableArray;

/**
 * Tupel.
 * 
 * @author Heiner K&uuml;cker
 */
final class ClassTypeparamsAndInheritTypeArgsTuple
{
	public final ImmutableArray<? extends AsmAbstractTypeParam> typeParams;

	public final ImmutableArray<? extends AsmType> superTypeArgs;

	//public final Map<String, List<? extends AsmType>> interfaceTypeArgs;
	public final ImmutableArray<? extends ImmutableArray<? extends AsmType>> interfaceTypeArgs;

	ClassTypeparamsAndInheritTypeArgsTuple(
    		final ImmutableArray<? extends AsmAbstractTypeParam> typeParams ,
    		final ImmutableArray<? extends AsmType> superTypeArgs ,
    		//final Map<String, List<? extends AsmType>> interfaceTypeArgs
    		final ImmutableArray<? extends ImmutableArray<? extends AsmType>> interfaceTypeArgs )
    {
    	this.typeParams = typeParams;
        this.superTypeArgs = superTypeArgs;
        this.interfaceTypeArgs = interfaceTypeArgs;
    }

	/**
	 * @return Extends-Typ-Parameter als Map Name zu Extends-Typ-Parameter
	 */
	public Map<String, AsmExtendsTypeParam> getExtendsTypeParamMap()
	{
		return toExtendsTypeParamMap( this.typeParams );
	}

	/**
	 * @return
	 */
	static Map<String, AsmExtendsTypeParam> toExtendsTypeParamMap(
			final ImmutableArray<? extends AsmAbstractTypeParam> typeParamArr )
	{
		if ( typeParamArr == null )
		{
			return Collections.<String, AsmExtendsTypeParam>emptyMap();
		}

		final Map<String, AsmExtendsTypeParam> result = new HashMap<>();

		for ( final AsmAbstractTypeParam typeParam : typeParamArr )
		{
			if ( typeParam instanceof AsmExtendsTypeParam )
			{
				result.put(
						typeParam.name ,
						(AsmExtendsTypeParam) typeParam );
			}
		}

		return result;
	}

	//// TODO wieder entfernen
	//static ClassTypeparamsAndInheritTypeArgsTupel create(
	//		final ImmutableArray<? extends AsmTypeParam> typeParams ,
	//		final ImmutableArray<? extends AsmType> superTypeArgs ,
	//		//final Map<String, List<? extends AsmType>> interfaceTypeArgs
	//		final ImmutableArray<? extends ImmutableArray<? extends AsmType>> interfaceTypeArgs )
	//{
	//	return new ClassTypeparamsAndInheritTypeArgsTupel(typeParams, superTypeArgs, interfaceTypeArgs);
	//}

}