package de.heinerkuecker.asm_improved;

import de.heinerkuecker.asm_improved.type.AsmTopLevelOrInnerClassTypeOrTypevar;
import de.heinerkuecker.asm_improved.type.AsmType;
import de.heinerkuecker.asm_improved.type.generics.param.AsmAbstractTypeParam;
import de.heinerkuecker.asm_improved.util.ImmutableArray;

/**
 * Tupel.
 * 
 * @author Heiner K&uuml;cker
 */
final class MethodTypeparamsAndReturnAndParamsAndExceptionsTuple
{
	public final ImmutableArray<? extends AsmAbstractTypeParam> typeParams;

	public final AsmType returnType;
	
	public final ImmutableArray<? extends AsmType> paramTypes;

    public final ImmutableArray<? extends AsmTopLevelOrInnerClassTypeOrTypevar> exceptions;

	/**
	 * @param returnType
	 * @param paramTypes
	 */
    MethodTypeparamsAndReturnAndParamsAndExceptionsTuple(
    		final ImmutableArray<? extends AsmAbstractTypeParam> typeParams ,
    		final AsmType returnType ,
            final ImmutableArray<? extends AsmType> paramTypes ,
            final ImmutableArray<? extends AsmTopLevelOrInnerClassTypeOrTypevar> exceptions )
    {
    	this.typeParams = typeParams;
        this.returnType = returnType;
        this.paramTypes = paramTypes;
        this.exceptions = exceptions;
    }

}