package de.heinerkuecker.asm_improved;

import de.heinerkuecker.asm_improved.util.JavaIdentifier;

/**
 * Tupel.
 * 
 * @author Heiner K&uuml;cker
 */
class TypeNameAndTypeArgsStrTuple
{
	final String typeName;
	final String typeArgsStr;

	TypeNameAndTypeArgsStrTuple(
			String typeName ,
			String typeArgsStr )
    {
		if ( ! JavaIdentifier.isJavaIdentifierOrDotSeparatedJavaIdentifier( typeName ) )
		{
			throw new IllegalArgumentException( typeName );
		}
		if ( typeArgsStr != null )
		{
			if ( ! ( typeArgsStr.charAt( 0 ) == '<' &&
					typeArgsStr.charAt( typeArgsStr.length() - 1 ) == '>' ) )
			{
				throw new IllegalArgumentException(
						typeArgsStr );
			}
		}

		this.typeName = typeName;
		this.typeArgsStr = typeArgsStr;
    }

	@Override
	public String toString()
    {
		return typeName + 
				( typeArgsStr != null ? typeArgsStr : "" );
    }
}