package de.heinerkuecker.asm_improved.asm_dom;

import java.util.ArrayList;
import java.util.List;

import org.objectweb.asm.AnnotationVisitor;

/**
 * Informationen einer Annotation.<br/>
 * 
 * Klasse zum Vermerken der beim Durchlaufen eines
 * {@link AnnotationVisitor} aufgetretenen Informationen.
 * 
 * @author Heiner K&uuml;cker
 */
public class AsmDomAnnotation
{
	/**
	 * Klassen-Information der Annotation.
	 */
	public final String desc;

	/**
	 * Ob die Annotation zur Laufzeit sichtbar ist.
	 * Wird von ASM immer mitgeliefert und deshalb hier vermerkt.
	 */
	public final boolean visibleAtRuntime;

	/**
	 * Werte/Parameter der Annotation.
	 */
	public final List<AsmDomAnnotationValue> values = new ArrayList<>();

	/**
	 * Konstruktor.
	 * 
	 * @param desc
	 * @param visibleAtRuntime
	 */
	AsmDomAnnotation(
			final String desc ,
			final boolean visibleAtRuntime )
	{
		super();
		this.desc = desc;
		this.visibleAtRuntime = visibleAtRuntime;
	}


}
