package de.heinerkuecker.asm_improved.asm_dom;

import java.util.ArrayList;
import java.util.List;

import org.objectweb.asm.AnnotationVisitor;

/**
 * Informationen einer Annotation, welche einer
 * Annotation als Wert/Parameter &uuml;bergeben
 * wird.<br/>
 * Klasse zum Vermerken der beim Durchlaufen eines
 * {@link AnnotationVisitor} aufgetretenen Informationen.
 *  
 * @author Heiner K&uuml;cker
 */
public class AsmDomAnnotationAnnotationValue
extends AsmDomAnnotationValue
{
	/**
	 * Klassen-Information der Annotation.
	 */
	public final String desc;

	/**
	 * Werte/Parameter der Annotation.
	 */
	public final List<AsmDomAnnotationValue> values = new ArrayList<>();

	/**
	 * Konstruktor.
	 * 
	 * @param name
	 * @param desc
	 */
	AsmDomAnnotationAnnotationValue(
			final String name ,
			final String desc )
	{
		super( name );
		this.desc = desc;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public String toString(
			final String indent )
	{
		return indent + this.getClass().getSimpleName()+ " " + this.name + " " + this.desc + "\n" + annotationValuesToString( indent , values );
	}

}
