package de.heinerkuecker.asm_improved.asm_dom;

import java.util.TreeMap;

/**
 * Primitiver Annotationswert.
 * 
 * @author Heiner K&uuml;cker
 */
public class AsmDomAnnotationPrimitiveValue
extends AsmDomAnnotationValue
{
	/**
	 * Primitiver Wert als Objekt der Wrapper-Klasse, niemals <code>null</code>
	 */
	public final Object value;

	/**
	 * Konstruktor.
	 * 
	 * @param name
	 * @param value
	 */
	public AsmDomAnnotationPrimitiveValue(
			final String name ,
			final Object value )
	{
		super( name );
		
		if ( value == null )
		{
			throw new IllegalArgumentException( "value is null" );
		}
		
		this.value = value;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public String toString(
			final String indent )
	{
		return indent + this.getClass().getSimpleName() + " " + this.name + " " + this.value;
	}

}
