package de.heinerkuecker.asm_improved.asm_dom;

import java.util.ArrayList;
import java.util.List;

import org.objectweb.asm.AnnotationVisitor;

/**
 * Klasse zum Vermerken der beim Durchlaufen eines
 * {@link AnnotationVisitor} aufgetretenen Informationen.
 *  
 * @author Heiner K&uuml;cker
 */
public class AsmDomArray
extends AsmDomAnnotationValue
{
	public final String desc;

	/**
	 * Liste der Array-Werte.
	 */
	public final List</*AsmDomAnnotationPrimitiveValue*/AsmDomAnnotationValue> values = new ArrayList<>();

	/**
	 * Konstruktor.
	 * 
	 * @param name
	 */
	AsmDomArray(
			final String name ,
			final String desc )
	{
		super( name );
		this.desc = desc;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public String toString(
			final String indent )
	{
		return indent + this.getClass().getSimpleName() + " " + this.name+ " " +  desc + "\n" + objValuesToString( indent , values );
	}

}
