package de.heinerkuecker.asm_improved.asm_dom;

import java.util.ArrayList;
import java.util.List;

import org.objectweb.asm.FieldVisitor;

/**
 * Klasse zum Vermerken der beim Durchlaufen eines
 * {@link FieldVisitor} aufgetretenen Informationen.
 *  
 * @author Heiner K&uuml;cker
 */
public final class AsmDomField
{
	public final int access;
	public final String name;
	public final String desc;
	public final String signature;
	public final Object initialValue;

	/**
	 * Annotationen des Felds.
	 */
	public final List<AsmDomAnnotation> annotations = new ArrayList<>();

	/**
	 * Annotationen des Feld-Typs.
	 */
	public final List<AsmDomTypeAnnotation> typeAnnotations = new ArrayList<>();

	/**
	 * Konstruktor.
	 * 
	 * @param name
	 * @param desc
	 */
	AsmDomField(
			final int access , 
			final String name ,
			final String desc ,
			final String signature ,
            final Object initialValue )
	{
		this.access = access;
		this.name = name;
		this.desc = desc;
		this.signature = signature;
		this.initialValue = initialValue;
	}

	/**
	 * {@inheritDoc}
	 */
	//@Override
	//public String toString(
	//		final String indent )
	//{
	//	return indent + this.getClass().getSimpleName() + this.name + " " + this.desc + "\n" + annotationValuesToString( indent , values );
	//}

}
