package de.heinerkuecker.asm_improved.type;

import de.heinerkuecker.asm_improved.AsmClasspathInfo;
import de.heinerkuecker.asm_improved.annotation_use.AsmAnnotationUse;
import de.heinerkuecker.asm_improved.type.member.AsmInnerClassType;
import de.heinerkuecker.asm_improved.util.Fqn;
import de.heinerkuecker.asm_improved.util.ImmutableArray;
import de.heinerkuecker.asm_improved.util.ImmutableMap;

/**
 * Gemeinsames Interface fr
 * {@link AsmClassType} und
 * {@link AsmInnerClassType}.
 * 
 * @author Heiner K&uuml;cker
 */
public abstract class AsmTopLevelOrInnerClassType
extends AsmTopLevelOrInnerClassTypeOrTypevar
{
	/**
	 * Konstruktor.
	 * 
	 * @param typeAnnotations
	 */
	protected AsmTopLevelOrInnerClassType(
			final ImmutableArray<? extends AsmAnnotationUse> typeAnnotations )
	{
		super( typeAnnotations );
	}

	/**
	 * @return gesamte Fqn, innere/geschachtelte Klasse und ussere/schachtelnde Klassen
	 */
	abstract public Fqn getEntireFqn();

	/**
	 * @return gesamte Typ-Argumente, innere/geschachtelte Klasse und ussere/schachtelnde Klassen
	 */
	abstract public ImmutableMap<String, AsmType> getEntireTypeArgs(
			final AsmClasspathInfo asmClasspathInfo );
}
