package de.heinerkuecker.asm_improved.type.generics.param;

import de.heinerkuecker.asm_improved.annotation_use.AsmAnnotationUse;
import de.heinerkuecker.asm_improved.type.AsmType;
import de.heinerkuecker.asm_improved.util.ImmutableArray;

/**
 * {@link AsmAbstractTypeParam} mit extends-Bound.
 * 
 * @author Heiner K&uuml;cker
 */
public final class AsmExtendsTypeParam
extends AsmAbstractTypeParam
{
	/**
	 * Bound-Type.
	 */
	public final AsmType boundType;

	/**
	 * Konstruktor.
	 * 
	 * @param name see {@link #name}
	 * @param boundType see {@link #boundType}
	 */
	public AsmExtendsTypeParam(
			final ImmutableArray<? extends AsmAnnotationUse> typeAnnotations ,
			String name ,
			final AsmType boundType )
	{
		super(
				typeAnnotations ,
				name );

		if ( boundType == null )
		{
			throw new IllegalArgumentException(
					"boundType is null" );
		}

		this.boundType = boundType;
	}

	/**
	 * Konstruktor.
	 * 
	 * @param name see {@link #name}
	 */
	public AsmExtendsTypeParam(
			String name ,
			final AsmType boundType )
	{
		this(
				//typeAnnotations
				null ,
				name ,
				boundType );
	}

	/**
	 * {@inheritDoc}
	 */
    @Override
    public String toString()
    {
    	return 
    			typeAnnotationsToStringWithDelimiterSpace() +
    			name + 
    			" extends " +
    			boundType;
    }

}
