package de.heinerkuecker.asm_improved.type.generics.param;

import de.heinerkuecker.asm_improved.annotation_use.AsmAnnotationUse;
import de.heinerkuecker.asm_improved.util.ImmutableArray;

/**
 * Type-Parameter ohne Bound.
 * 
 * @author Heiner K&uuml;cker
 */
public final class AsmUnboundedTypeParam
extends AsmAbstractTypeParam
{
	/**
	 * @param name
	 */
	public AsmUnboundedTypeParam(
			final ImmutableArray<? extends AsmAnnotationUse> typeAnnotations ,
			String name )
	{
		super(
				typeAnnotations ,
				name );
	}

	/**
	 * @param name
	 */
	public AsmUnboundedTypeParam(
			String name )
	{
		this(
				//typeAnnotations
				null ,
				name );
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public String toString()
	{
		return typeAnnotationsToStringWithDelimiterSpace() + this.name;
	}

}
