package de.heinerkuecker.asm_improved.type.primitive;

import java.util.Map;

import de.heinerkuecker.asm_improved.AsmClasspathInfo;
import de.heinerkuecker.asm_improved.annotation_use.AsmAnnotationUse;
import de.heinerkuecker.asm_improved.type.AsmType;
import de.heinerkuecker.asm_improved.type.AsmTypePath;
import de.heinerkuecker.asm_improved.util.ImmutableArray;

/**
 * short-Type
 * 
 * @author Heiner K&uuml;cker
 */
public final class AsmShort
extends AsmPrimitive
{
	/**
	 * Singleton-Instanz.
	 */
	public static final AsmShort INSTANCE = new AsmShort();

	/**
	 * 
	 */
	public AsmShort(
    		final ImmutableArray<AsmAnnotationUse> typeAnnotations )
	{
		super( typeAnnotations );
	}

	/**
	 * 
	 */
	public AsmShort()
	{
		super( null );
	}

	@Override
	String primitiveName()
	{
		return "short";
	}

	/**
	 * {@inheritDoc}
	 */
    @Override
    public boolean isAssignableFrom(
    		final AsmType typeToTest ,
    		final AsmClasspathInfo asmClasspathInfo )
    {
    	/*
    	short s = 'a';
    	//s = Integer.MAX_VALUE;
    	//TODO Sonderfall Zuweisung int-Wert, wenn Wert in Short-Range
    	s = ( (int) Short.MAX_VALUE );
    	s = ( (int) Short.MIN_VALUE );
    	//s = ( (int) Short.MAX_VALUE ) + 1;
    	//s = ( (int) Short.MIN_VALUE ) - 1;
    	*/
    	return typeToTest instanceof AsmChar ||
    			typeToTest instanceof AsmShort ||
    			typeToTest instanceof AsmByte;
    }

	@Override
	public AsmShort cloneAddTypeAnnotations(
			final Map<AsmTypePath, ImmutableArray<AsmAnnotationUse>> typeAnnotationsMap ,
			final AsmTypePath typePath )
	{
		if ( this.typeAnnotations != null )
			// zweimal Typ-Annotationen hinzufgen sollte nicht vorkommen
		{
			throw new IllegalStateException();
		}

		return new AsmShort(
				typeAnnotationsMap.get( typePath ) );
		//throw new RuntimeException( "nicht fertig" );
	}

}
