package de.heinerkuecker.asm_improved.type.util;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.Map.Entry;

import de.heinerkuecker.asm_improved.AsmClassInfo;
import de.heinerkuecker.asm_improved.AsmClasspathInfo;
import de.heinerkuecker.asm_improved.type.AsmArray;
import de.heinerkuecker.asm_improved.type.AsmClassType;
import de.heinerkuecker.asm_improved.type.AsmType;
import de.heinerkuecker.asm_improved.type.generics.arg.AsmExtendsWildcard;
import de.heinerkuecker.asm_improved.type.generics.arg.AsmSuperWildcard;
import de.heinerkuecker.asm_improved.type.generics.arg.AsmUnboundWildcard;
import de.heinerkuecker.asm_improved.type.generics.param.AsmAbstractTypeParam;
import de.heinerkuecker.asm_improved.type.generics.param.AsmExtendsTypeParam;
import de.heinerkuecker.asm_improved.type.generics.var.AsmTypevar;
import de.heinerkuecker.asm_improved.type.member.AsmInnerClassType;
import de.heinerkuecker.asm_improved.util.CollectionUtil;
import de.heinerkuecker.asm_improved.util.Fqn;
import de.heinerkuecker.asm_improved.util.ImmutableArray;
import de.heinerkuecker.asm_improved.util.ImmutableMap;

/**
 * used by Java8CodeDomCreator
 * 
 * @author Heiner K&uuml;cker
 */
public final class InheritTypeArgsUtil
{

	/**
	 * Konstruktor private,
	 * Instanziieren verboten,
	 * Util-Klasse.
	 */
	private InheritTypeArgsUtil()
	{
		super();
	}

	/*
	 * Bei einer inneren Klasse (nicht static) kann ein Typ-Parameter-Name mehrmals auftauchen
	 * 
	 * Outer<T>.Inner<T>
	 * 
	 * Deshalb wird eine Liste von Maps zurckgegeben.
	 * 
	 */
	//public static ImmutableMap<String, AsmType> createTypeParamNameToTypeArgMap(
	//		final ImmutableArray<? extends ImmutableArray<? extends AsmAbstractTypeParam>> typeParams ,
	//		//final List<? extends AsmType> typeArgs
	//		final ImmutableArray<? extends ImmutableArray<? extends AsmType>> typeArgs )
	//{
	//	//if ( typeParams == null )
	//	if ( CollectionUtil.isNullOrEmpty( typeParams ) ||
	//			( typeParams.size() == 1 &&
	//					CollectionUtil.isNullOrEmpty( typeParams.get( 0 ) ) ) )
	//	{
	//		return null;
	//	}
	//
	//	if ( CollectionUtil.isNullOrEmpty( typeArgs ) )
	//		// eventuell raw type
	//	{
	//		return null;
	//	}
	//
	//	if ( typeParams.size() != typeArgs.size() )
	//	{
	//		throw new IllegalArgumentException(
	//				typeParams + " " + typeArgs );
	//	}
	//
	//	final List<ImmutableMap<String, AsmType>> resultList = new ArrayList<>();
	//
	//	for ( int typeArgIndex = 0 ; typeArgIndex < typeArgs.size() ; typeArgIndex++ )
	//	{
	//		final ImmutableArray<? extends AsmAbstractTypeParam> subTypeParams = typeParams.get(typeArgIndex);
	//
	//		final ImmutableArray<? extends AsmType> subTypeArgs = typeArgs.get( typeArgIndex );
	//
	//		if ( subTypeParams.size() != subTypeArgs.size() )
	//		{
	//			throw new IllegalArgumentException(
	//					subTypeParams + " " + subTypeArgs );
	//		}
	//
	//		final Map<String, AsmType> inheritanceTypeParamNameToTypeArgMap =
	//				new HashMap<>();
	//
	//		for ( int subTypeArgIndex = 0 ; subTypeArgIndex < subTypeArgs.size() ; subTypeArgIndex++ )
	//		{
	//			final AsmAbstractTypeParam typeParam = subTypeParams.get( subTypeArgIndex );
	//
	//			final AsmType typeArg = subTypeArgs.get( subTypeArgIndex );
	//
	//			inheritanceTypeParamNameToTypeArgMap.put(
	//					typeParam.name ,
	//					typeArg );
	//		}
	//
	//		resultList.add(
	//				ImmutableMap.create(
	//						inheritanceTypeParamNameToTypeArgMap ) );
	//	}
	//
	//	//return ImmutableArray.create( resultList );
	//	return resultList.get( 0 );
	//}
	//public static ImmutableMap<String, AsmType> createTypeParamNameToTypeArgMap(
	//		final ImmutableMap<String,? extends AsmAbstractTypeParam> typeParams ,
	//		final ImmutableMap<String,? extends AsmType> typeArgs )
	//{
	//	if ( typeParams == null || typeParams.isEmpty() )
	//	{
	//		return null;
	//	}
	//
	//	if ( typeArgs == null || typeArgs.isEmpty() )
	//		// eventuell raw type
	//	{
	//		return null;
	//	}
	//
	//	if ( typeParams.size() != typeArgs.size() )
	//	{
	//		throw new IllegalArgumentException(
	//				typeParams + " " + typeArgs );
	//	}
	//
	//	final Map<String, AsmType> result = new HashMap<>();
	//
	//	for ( int typeArgIndex = 0 ; typeArgIndex < typeArgs.size() ; typeArgIndex++ )
	//	{
	//		final ImmutableArray<? extends AsmAbstractTypeParam> subTypeParams = typeParams.get(typeArgIndex);
	//
	//		final ImmutableArray<? extends AsmType> subTypeArgs = typeArgs.get( typeArgIndex );
	//
	//		if ( subTypeParams.size() != subTypeArgs.size() )
	//		{
	//			throw new IllegalArgumentException(
	//					subTypeParams + " " + subTypeArgs );
	//		}
	//
	//		final Map<String, AsmType> inheritanceTypeParamNameToTypeArgMap =
	//				new HashMap<>();
	//
	//		for ( int subTypeArgIndex = 0 ; subTypeArgIndex < subTypeArgs.size() ; subTypeArgIndex++ )
	//		{
	//			final AsmAbstractTypeParam typeParam = subTypeParams.get( subTypeArgIndex );
	//
	//			final AsmType typeArg = subTypeArgs.get( subTypeArgIndex );
	//
	//			inheritanceTypeParamNameToTypeArgMap.put(
	//					typeParam.name ,
	//					typeArg );
	//		}
	//
	//		resultList.add(
	//				ImmutableMap.create(
	//						inheritanceTypeParamNameToTypeArgMap ) );
	//	}
	//
	//	return resultList.get( 0 );
	//}

	// TODO diese Methode zusammen in eine Klasse mit de.heinerkuecker.parser.java8.convert.Java8CodeDomCreatorInheritTypeArgsUtil.getSuperClassesOrInterfaceTypeArgMap(ClassInfo, ImmutableArray<? extends AsmType>, Map<String, ? extends AsmType>, ClassInfo, AsmClasspathInfo) und private machen
	private static ImmutableMap<String, AsmType> mapTypeArgsForTypeVars(
			final ImmutableMap<String, ? extends AsmAbstractTypeParam>  typeParams ,
			final ImmutableMap<String, ? extends AsmType> inheritanceTypeArgs ,
			final ImmutableMap<String, ? extends AsmType> inheritanceTypeParamNameToTypeArgMap )
	{
		if ( typeParams == null || typeParams.isEmpty() )
		{
			return null;
		}

		if ( inheritanceTypeArgs == null || inheritanceTypeArgs.isEmpty() )
			// eventuell raw type
		{
			return null;
		}

		if ( typeParams.size() != inheritanceTypeArgs.size() )
		{
			throw new IllegalArgumentException(
					typeParams + " " + inheritanceTypeArgs );
		}

		final Map<String, AsmType> result = new HashMap<>();

		for ( final Entry<String, ? extends AsmType> inheritanceTypeArgEntry : inheritanceTypeArgs.entrySet() )
		{
			//final AsmAbstractTypeParam subTypeParam = typeParams.get( inheritanceTypeArgEntry.getKey() );

			final AsmType typeArg = inheritanceTypeArgEntry.getValue();

			if ( typeArg instanceof AsmClassType ||
					typeArg instanceof AsmInnerClassType ||
					typeArg instanceof AsmArray )
			{
				result.put(
						inheritanceTypeArgEntry.getKey() ,
						typeArg );
			}
			else if ( typeArg instanceof AsmTypevar )
			{
				if ( inheritanceTypeParamNameToTypeArgMap == null )
				{
					result.put(
							inheritanceTypeArgEntry.getKey() ,
							AsmClassType.JAVA_LANG_OBJECT );
				}
				else
				{
					result.put(
							inheritanceTypeArgEntry.getKey() ,
							inheritanceTypeParamNameToTypeArgMap/*.get(
									typeArgIndex )*/.get(
											( (AsmTypevar) typeArg ).name ) );
				}
			}
			else if ( typeArg instanceof AsmExtendsWildcard )
			{
				result.put(
						inheritanceTypeArgEntry.getKey() ,
						( (AsmExtendsWildcard) typeArg ).boundType );
			}
			else if ( typeArg instanceof AsmSuperWildcard )
			{
				result.put(
						inheritanceTypeArgEntry.getKey() ,
						( (AsmSuperWildcard) typeArg ).boundType );
			}
			else if ( typeArg instanceof AsmUnboundWildcard )
			{
				result.put(
						inheritanceTypeArgEntry.getKey() ,
						AsmClassType.JAVA_LANG_OBJECT );
			}
			else
			{
				throw new IllegalStateException(
						String.valueOf( typeArg ) + " " +
								( typeArg != null ? typeArg.getClass() : "" ) );
			}
		}

		return ImmutableMap.create( result );
	}

	/**
	 * Diese Methode gibt
	 * fr den bergebenen Typ-Parameter-Name
	 * das im konkreten Typ festgelegte
	 * Typ-Argument zurck.
	 * <br/><br/>
	 * Dabei wird beachtet, dass durch
	 * Vererbung/Implementierung von
	 * Super-Klassen/Interfaces
	 * die Typ-Parameter-Namen
	 * umgemappt werden knnen.
	 * 
	 * @param inheritClassInfo
	 * @param inheritanceTypeArgs
	 * @param inheritanceTypeParamNameToTypeArgMap
	 * @param indent Einrckung (nur fr Debug/Develop)
	 * @param typeParamHavingClassInfo
	 * @param typeParamNameToGetTypeArg
	 * @return
	 */
	//public static ImmutableMap<String, AsmType> getSuperClassesOrInterfaceTypeArgMap(
	//		final AsmClassInfo inheritClassInfo ,
	//		final ImmutableMap<String,? extends AsmType> inheritanceTypeArgs ,
	//		final ImmutableMap<String, AsmType> inheritanceTypeParamNameToTypeArgMap ,
	//		//final String indent ,
	//		final AsmClassInfo typeParamHavingClassInfo ,
	//		//final String typeParamNameToGetTypeArg
	//		final AsmClasspathInfo asmClasspathInfo )
	//{
	//	final ImmutableArray<? extends ImmutableArray<? extends AsmType>> forTypeVarsMappedTypeArgs =
	//			InheritTypeArgsUtil.mapTypeArgsForTypeVars(
	//					inheritClassInfo./*typeParams*/getTypeparamsIncludeOuterClass( asmClasspathInfo ) ,
	//					inheritanceTypeArgs ,
	//					inheritanceTypeParamNameToTypeArgMap );
	//
	//	/*System.out.print( indent );
	//	System.out.print( inheritClassInfo.getFullQualifiedClassName() );
	//	System.out.print( inheritClassInfo.typeParams != null ? inheritClassInfo.typeParams : "" );
	//	// TODO diese Typ-Argumente werden um-ge-mappt: System.out.print( inheritanceTypeArgs != null ? inheritanceTypeArgs : "" );
	//	System.out.print( forTypeVarsMappedTypeArgs != null ? forTypeVarsMappedTypeArgs : "" );
	//	System.out.println();*/
	//
	//	final ImmutableMap<String,AsmType> mappedTypeParamNameToTypeArgMap =
	//			createTypeParamNameToTypeArgMap(
	//					inheritClassInfo./*typeParams*/getTypeparamsIncludeOuterClass( asmClasspathInfo ) ,
	//					forTypeVarsMappedTypeArgs );
	//
	//	if ( inheritClassInfo.fqn.toFqnStr().equals(
	//			typeParamHavingClassInfo.fqn.toFqnStr() ) )
	//	{
	//		//return mappedTypeParamNameToTypeArgMap.get( typeParamNameToGetTypeArg );
	//		return mappedTypeParamNameToTypeArgMap;
	//	}
	//
	//	if ( inheritClassInfo.superType != null )
	//	{
	//		//final AsmType typeArg = searchSuperClassesOrInterfaceTypeArg(
	//		final ImmutableMap<String, AsmType> superClassTypeArgMap =
	//				getSuperClassesOrInterfaceTypeArgMap(
	//						//inheritClassInfo.superClassInfoLazy.get() ,
	//	        			asmClasspathInfo.getClassInfoMandantory( inheritClassInfo.superType.fqn ) ,
	//						//inheritClassInfo.superTypeArgs ,
	//	        			inheritClassInfo.superType./*typeArgs*/getEntireTypeArgs(asmClasspathInfo) ,
	//						mappedTypeParamNameToTypeArgMap ,
	//						//indent + "\t" ,
	//						typeParamHavingClassInfo ,
	//						//typeParamNameToGetTypeArg
	//						asmClasspathInfo );
	//
	//		//if ( typeArg != null )
	//		//	// Typ-Argument gefunden
	//		//{
	//		//	return typeArg;
	//		//}
	//		if ( superClassTypeArgMap != null )
	//			// Typ-Argument gefunden
	//		{
	//			return superClassTypeArgMap;
	//		}
	//	}
	//
	//	if ( inheritClassInfo.interfaceTypes != null )
	//	{
	//		//for ( ClassInfoLazyAndTypeArgsTupel interfaceLazy : inheritClassInfo.interfaceLazys )
	//		for ( AsmClassType interfaceType : inheritClassInfo.interfaceTypes )
	//		{
	//			final AsmClassInfo interfaceClassInfo =
	//					//interfaceLazy.classInfoLazy.get()
	//        			asmClasspathInfo.getClassInfoMandantory( interfaceType.fqn );
	//
	//			//final ImmutableArray<? extends AsmType> interfaceTypeArgs = interfaceType.typeArgs;
	//			final ImmutableMap<String,? extends AsmType> interfaceTypeArgs = interfaceType.getEntireTypeArgs(asmClasspathInfo);
	//
	//			//final AsmType typeArg = searchSuperClassesOrInterfaceTypeArg(
	//			final ImmutableMap<String, AsmType> interfaceTypeArgMap =
	//					getSuperClassesOrInterfaceTypeArgMap(
	//							interfaceClassInfo ,
	//							interfaceTypeArgs ,
	//							mappedTypeParamNameToTypeArgMap ,
	//							//indent + "\t" ,
	//							typeParamHavingClassInfo ,
	//							//typeParamNameToGetTypeArg
	//							asmClasspathInfo );
	//
	//			//if ( typeArg != null )
	//			//	// Typ-Argument gefunden
	//			//{
	//			//	return typeArg;
	//			//}
	//			if ( interfaceTypeArgMap != null )
	//				// Typ-Argument gefunden
	//			{
	//				return interfaceTypeArgMap;
	//			}
	//		}
	//	}
	//
	//	// Typ-Argument nicht gefunden
	//	return null;
	//}
	@Deprecated // von dieser Methode werden Bound-Verstaerkungen innnerhalb der Vererbungshierarchie nicht beachtet
	public static ImmutableMap<String, AsmType> getSuperClassesOrInterfaceTypeArgMap(
			final AsmClassInfo inheritClassInfo ,
			final ImmutableMap<String, ? extends AsmType> inheritanceTypeArgs ,
			final ImmutableMap<String, ? extends AsmType> inheritanceTypeParamNameToTypeArgMap ,
			//final String indent ,
			final AsmClassInfo typeParamHavingClassInfo ,
			//final String typeParamNameToGetTypeArg
			final AsmClasspathInfo asmClasspathInfo )
	{
		final ImmutableMap<String,AsmType> forTypeVarsMappedTypeArgs =
				InheritTypeArgsUtil.mapTypeArgsForTypeVars(
						inheritClassInfo.getTypeparamsIncludeOuterClass( asmClasspathInfo ) ,
						inheritanceTypeArgs ,
						inheritanceTypeParamNameToTypeArgMap );

		/*System.out.print( indent );
		System.out.print( inheritClassInfo.getFullQualifiedClassName() );
		System.out.print( inheritClassInfo.typeParams != null ? inheritClassInfo.typeParams : "" );
		// TODO diese Typ-Argumente werden um-ge-mappt: System.out.print( inheritanceTypeArgs != null ? inheritanceTypeArgs : "" );
		System.out.print( forTypeVarsMappedTypeArgs != null ? forTypeVarsMappedTypeArgs : "" );
		System.out.println();*/

		//final ImmutableMap<String,AsmType> mappedTypeParamNameToTypeArgMap =
		//		createTypeParamNameToTypeArgMap(
		//				inheritClassInfo.getTypeparamsIncludeOuterClass( asmClasspathInfo ) ,
		//				forTypeVarsMappedTypeArgs );

		if ( inheritClassInfo.fqn.toFqnStr().equals(
				typeParamHavingClassInfo.fqn.toFqnStr() ) )
		{
			//return mappedTypeParamNameToTypeArgMap.get( typeParamNameToGetTypeArg );
			//return mappedTypeParamNameToTypeArgMap;
			return forTypeVarsMappedTypeArgs;
		}

		if ( inheritClassInfo.superType != null )
		{
			//final AsmType typeArg = searchSuperClassesOrInterfaceTypeArg(
			final ImmutableMap<String, AsmType> superClassTypeArgMap =
					getSuperClassesOrInterfaceTypeArgMap(
							//inheritClassInfo.superClassInfoLazy.get() ,
							asmClasspathInfo.getClassInfoMandantory( inheritClassInfo.superType.fqn ) ,
							//inheritClassInfo.superTypeArgs ,
							inheritClassInfo.superType./*typeArgs*/getEntireTypeArgs(asmClasspathInfo) ,
							//mappedTypeParamNameToTypeArgMap
							forTypeVarsMappedTypeArgs ,
							//indent + "\t" ,
							typeParamHavingClassInfo ,
							//typeParamNameToGetTypeArg
							asmClasspathInfo );

			//if ( typeArg != null )
			//	// Typ-Argument gefunden
			//{
			//	return typeArg;
			//}
			if ( superClassTypeArgMap != null )
				// Typ-Argument gefunden
			{
				return superClassTypeArgMap;
			}
		}

		if ( inheritClassInfo.interfaceTypes != null )
		{
			//for ( ClassInfoLazyAndTypeArgsTupel interfaceLazy : inheritClassInfo.interfaceLazys )
			for ( AsmClassType interfaceType : inheritClassInfo.interfaceTypes )
			{
				final AsmClassInfo interfaceClassInfo =
						//interfaceLazy.classInfoLazy.get()
						asmClasspathInfo.getClassInfoMandantory( interfaceType.fqn );

				//final ImmutableArray<? extends AsmType> interfaceTypeArgs = interfaceType.typeArgs;
				final ImmutableMap<String,? extends AsmType> interfaceTypeArgs = interfaceType.getEntireTypeArgs(asmClasspathInfo);

				//final AsmType typeArg = searchSuperClassesOrInterfaceTypeArg(
				final ImmutableMap<String, AsmType> interfaceTypeArgMap =
						getSuperClassesOrInterfaceTypeArgMap(
								interfaceClassInfo ,
								interfaceTypeArgs ,
								//mappedTypeParamNameToTypeArgMap
								forTypeVarsMappedTypeArgs ,
								//indent + "\t" ,
								typeParamHavingClassInfo ,
								//typeParamNameToGetTypeArg
								asmClasspathInfo );

				//if ( typeArg != null )
				//	// Typ-Argument gefunden
				//{
				//	return typeArg;
				//}
				if ( interfaceTypeArgMap != null )
					// Typ-Argument gefunden
				{
					return interfaceTypeArgMap;
				}
			}
		}

		// Typ-Argument nicht gefunden
		return null;
	}

	public static SuperClassesOrInterfaceInheritBoundReinforcedTypeArgMapOption getSuperClassesOrInterfaceInheritBoundReinforcedTypeArgMap(
			final AsmClassInfo inheritClassInfo ,
			final ImmutableMap<String, ? extends AsmType> inheritanceTypeArgs ,
			//final ImmutableMap<String, ? extends AsmType> inheritanceTypeParamNameToTypeArgMap ,
			final AsmClassInfo typeParamHavingClassInfo ,
			final AsmClasspathInfo asmClasspathInfo )
	{
		if ( inheritClassInfo.fqn.equals( typeParamHavingClassInfo.fqn ) )
			// Rekursion terminiert
		{
			if ( CollectionUtil.isNullOrEmpty( inheritClassInfo.typeParams ) )
				// Klasse hat keine Typ-Parameter
			{
				//return null;
				return SuperClassesOrInterfaceInheritBoundReinforcedTypeArgMapOption.Empty.INSTANCE;
			}

			if ( inheritanceTypeArgs == null || inheritanceTypeArgs.isEmpty() )
				// vermutlich Raw-Type
			{
				return new SuperClassesOrInterfaceInheritBoundReinforcedTypeArgMapOption.Result(
						typeParamHavingClassInfo.getBoundResolvedTypeParamMap() );
			}

			final Map<String, AsmType> result = new HashMap<>();

			for ( final AsmAbstractTypeParam inheritClassInfoTypeParam : inheritClassInfo.typeParams )
			{
				final String inheritClassInfoTypeParamName = inheritClassInfoTypeParam.name;

				if ( inheritanceTypeArgs.containsKey( inheritClassInfoTypeParamName ) )
					// Type-Argument bindet staerker als Bound des Typ-Parameters
				{
					result.put(
							inheritClassInfoTypeParamName ,
							inheritanceTypeArgs.get( inheritClassInfoTypeParamName ) );
				}
				else
				{
					if ( inheritClassInfoTypeParam instanceof AsmExtendsTypeParam )
					{
						result.put(
								inheritClassInfoTypeParamName ,
								( (AsmExtendsTypeParam) inheritClassInfoTypeParam ).boundType );
					}
				}
			}

			return new SuperClassesOrInterfaceInheritBoundReinforcedTypeArgMapOption.Result(
					ImmutableMap.create( result ) );
		}

		if ( ! ( inheritClassInfo.superType == null ||
				inheritClassInfo.superType.fqn.equals( Fqn.JAVA_LANG_OBJECT_FQN ) ) )
		{
			final AsmClassInfo superClassInfo = asmClasspathInfo.getClassInfoMandantory( inheritClassInfo.superType.fqn );

			ImmutableMap<String,AsmType> renameAndReinforceTypeArgs =
					renameAndReinforceTypeArgs(
							inheritClassInfo ,
							inheritClassInfo.getBoundResolvedTypeParamMap() ,
							inheritClassInfo.superType.typeArgs ,
							superClassInfo ,
							asmClasspathInfo );

			final SuperClassesOrInterfaceInheritBoundReinforcedTypeArgMapOption superResult =
					getSuperClassesOrInterfaceInheritBoundReinforcedTypeArgMap(
							superClassInfo ,
							renameAndReinforceTypeArgs ,
							typeParamHavingClassInfo ,
							asmClasspathInfo );

			if ( superResult.isPresent() )
			{
				return superResult;
			}
		}

		if ( ! ( CollectionUtil.isNullOrEmpty( inheritClassInfo.interfaceTypes  ) ) )
			// TODO was ist, wenn ein Interface ueber verschiedene Vererbungs-Pfade implementiert wird, aber unterschiedliche, sich wiedersprechende Bounds, wehrt der Compiler ab
		{
			for ( final AsmClassType inheritClassInfoInterfaceType : inheritClassInfo.interfaceTypes )
			{
				final AsmClassInfo interfaceClassInfo = asmClasspathInfo.getClassInfoMandantory( inheritClassInfoInterfaceType.fqn );

				ImmutableMap<String,AsmType> renameAndReinforceTypeArgs =
						renameAndReinforceTypeArgs(
								inheritClassInfo ,
								inheritClassInfo.getBoundResolvedTypeParamMap() ,
								inheritClassInfoInterfaceType.typeArgs ,
								interfaceClassInfo ,
								asmClasspathInfo );

				final SuperClassesOrInterfaceInheritBoundReinforcedTypeArgMapOption interfaceResult =
						getSuperClassesOrInterfaceInheritBoundReinforcedTypeArgMap(
								interfaceClassInfo ,
								renameAndReinforceTypeArgs ,
								typeParamHavingClassInfo ,
								asmClasspathInfo );

				if ( interfaceResult.isPresent() )
				{
					return interfaceResult;
				}

			}
		}

		return SuperClassesOrInterfaceInheritBoundReinforcedTypeArgMapOption.Empty.INSTANCE;
	}

	/**
	 * Wenn in der Methode {@link #getSuperClassesOrInterfaceInheritBoundReinforcedTypeArgMap}
	 * in einem bestimmten Vererbungspfad die gesuchte Klasse/Interface nicht vorhanden ist,
	 * kann dies durch Rueckgabe {@link Empty} signalisiert werden.
	 */
	public interface SuperClassesOrInterfaceInheritBoundReinforcedTypeArgMapOption
	{
		boolean isPresent();

		ImmutableMap<String, AsmType> getResult();

		/**
		 * Kein Resultat.
		 */
		public static class Empty
		implements SuperClassesOrInterfaceInheritBoundReinforcedTypeArgMapOption
		{
			/**
			 * Singleton-Instanz.
			 */
			public static final Empty INSTANCE = new Empty();

			/**
			 * Konstruktor.
			 */
			private Empty()
			{
			}

			@Override
			public boolean isPresent()
			{
				return false;
			}

			@Override
			public ImmutableMap<String, AsmType> getResult()
			{
				throw new UnsupportedOperationException();
			}
		}

		public static class Result
		implements SuperClassesOrInterfaceInheritBoundReinforcedTypeArgMapOption
		{
			final ImmutableMap<String, AsmType> result;

			public Result(
					final ImmutableMap<String, AsmType> result )
			{
				this.result = result;
			}

			@Override
			public boolean isPresent()
			{
				return true;
			}

			@Override
			public ImmutableMap<String, AsmType> getResult()
			{
				return result;
			}

		}
	}

	/**
	 * 
	 * @param inheritClassInfo direkte Unter-Klasse/-Interface von typeParamHavingClassInfo
	 * @param inheritanceTypeParamNameToTypeArgMap Typ-Parameter der Unter-Klasse/-Interface
	 * @param inheritanceTypeArgs Typ-Argumente der Ober-Klasse/-Interface
	 * @param typeParamHavingClassInfo Ober-Klasse/-Interface
	 * @param asmClasspathInfo AsmClasspathInfo
	 * @return Map mit den Namen der Typ-Parameter der Ober-Klasse/-Interface zu den gebundenen Typen oder den eventuell verstaerkten Bounds
	 */
	private static ImmutableMap<String, AsmType> renameAndReinforceTypeArgs(
			final AsmClassInfo inheritClassInfo ,
			final ImmutableMap<String, ? extends AsmType> inheritanceTypeParamNameToTypeArgMap ,
			final ImmutableArray<? extends AsmType> inheritanceTypeArgs ,
			final AsmClassInfo typeParamHavingClassInfo ,
			final AsmClasspathInfo asmClasspathInfo )
	{
		if ( CollectionUtil.isNullOrEmpty( typeParamHavingClassInfo.typeParams ) )
		{
			return null;
		}

		final Map<String, AsmType> result = new HashMap<>();

		if ( inheritanceTypeArgs != null )
		{
			final Iterator<? extends AsmType> inheritanceTypeArgsIterator =  inheritanceTypeArgs.iterator();

			for ( final AsmAbstractTypeParam typeParamHavingClassInfoTypeParam : typeParamHavingClassInfo.typeParams )
			{
				// Es wird davon ausgegangen, dass es fuer jeden Typ-Parameter genau ein Typ-Argument an der entsprechenden Position gibt
				final AsmType inheritanceTypeArg = inheritanceTypeArgsIterator.next();

				if ( inheritanceTypeArg instanceof AsmTypevar &&
						inheritanceTypeParamNameToTypeArgMap != null )
				{
					final AsmType typevarBound =
							inheritanceTypeParamNameToTypeArgMap.get(
									( (AsmTypevar) inheritanceTypeArg ).name );

					if ( typevarBound != null )
					{
						final AsmType resolvedTypevarBound =
								typevarBound.resolveBound(
										inheritanceTypeParamNameToTypeArgMap );

						result.put(
								typeParamHavingClassInfoTypeParam.name ,
								resolvedTypevarBound );
					}
				}
				//else if ( inheritanceTypeArg instanceof AsmExtendsWildcard )
				//{
				//	result.put(
				//			typeParamHavingClassInfoTypeParam.name ,
				//			resolvedTypevarBound );
				//}
				else
				{
					//throw new IllegalStateException( String.valueOf( typeParamHavingClassInfoTypeParam ) );

					result.put(
							typeParamHavingClassInfoTypeParam.name ,
							inheritanceTypeArg );
				}
			}

			return ImmutableMap.create( result );
		}

		return typeParamHavingClassInfo.getBoundResolvedTypeParamMap();
	}

}
