package de.heinerkuecker.asm_improved.util;

import java.util.Collection;
import java.util.List;

/**
 * TODO
 * 
 * @author Heiner K&uuml;cker
 */
public final class CollectionUtil
{

	/**
	 * Konstruktor private,
	 * Instanziieren verboten,
	 * Util-Klasse.
	 */
	private CollectionUtil()
	{
		super();
	}

	/**
	 * 
	 * @param collToCheck
	 * @return <code>null</cede> or {@link Collection#isEmpty()}
	 */
	public static boolean isNullOrEmpty(
			final Collection<?> collToCheck )
	{
		return collToCheck == null || collToCheck.isEmpty();
	}
	
	/**
	 * 
	 * @param collToCheck
	 * @return <code>null</cede> or {@link Collection#isEmpty()}
	 */
	public static boolean isNullOrEmpty(
			final ImmutableArray<?> collToCheck )
	{
		return collToCheck == null || collToCheck.isEmpty();
	}
	
	/**
	 * 
	 * @param collToCheck
	 * @return <code>null</cede> or {@link Collection#isEmpty()}
	 */
	public static boolean isNullOrEmpty(
			final Iterable<?> iterableToCheck )
	{
		return iterableToCheck == null 
				|| 
				//collToCheck.isEmpty()
				( ! iterableToCheck.iterator().hasNext() );
	}

	/**
	 * 
	 * @param list abzufragende Liste
	 * @param index Element-Index
	 * @return Element an Index oder <code>null</code>, wenn Index zu gross 
	 */
	public static <T> T getAtIndexOrNullIfIndexOutOfBound(
			final List<T> list ,
			final int index )
	{
		if ( index >= list.size() )
		{
			return null;
		}
		return list.get( index );
	}

	/**
	 * 
	 * @param list abzufragende Liste
	 * @param index Element-Index
	 * @return Element an Index oder <code>null</code>, wenn Liste <code>null</code> oder wenn Index zu gross 
	 */
	public static <T> T getNullSafeAtIndexOrNullIfIndexOutOfBound(
			final List<T> list ,
			final int index )
	{
		if ( list == null )
		{
			return null;
		}
		return getAtIndexOrNullIfIndexOutOfBound(
				list ,
				index );
	}
	
}
