package de.heinerkuecker.asm_improved.util;

import java.util.ArrayList;
import java.util.Collection;

/**
 * Erweiterte {@link ArrayList}.
 * 
 * @param <E> Element type
 * @author Heiner K&uuml;cker
 */
public class ExtendedArrayList<E>
extends ArrayList<E>
implements ExtendedList<E>
{

	/**
	 * Generated by Eclipse.
	 */
    private static final long serialVersionUID = -5220270900131418479L;

	/**
	 * 
	 */
	public ExtendedArrayList()
	{
		super();
	}

	/**
	 * @param initialCapacity
	 */
	public ExtendedArrayList(
			final int initialCapacity )
	{
		super( initialCapacity );
	}

	/**
	 * @param c
	 */
	public ExtendedArrayList(
			final Collection<? extends E> c )
	{
		super( c );
	}

	/**
	 * @param itbl
	 */
	public ExtendedArrayList(
			final Iterable<? extends E> itbl )
	{
		super();
		addAll( itbl );
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public boolean addAll(
			final Iterable<? extends E> itbl )
	{
		boolean result = false;

		for ( E e : itbl )
		{
			result |= add( e );
		}

		return result;
	}

	/**
	 * {@inheritDoc}
	 */
    @Override
    public boolean addAll(
    		final SizeableIterable<? extends E> itbl )
    {
    	ensureCapacity( this.size() + itbl.size() );

		boolean result = false;

		for ( E e : itbl )
		{
			result |= add( e );
		}

		return result;
    }

}
