package de.heinerkuecker.asm_improved.util;

import java.util.List;

/**
 * Erweiterung des Interface {@link List}
 * um Komfort-Methoden.
 * 
 * @param <E> Element type
 * @author Heiner K&uuml;cker
 */
public interface ExtendedList<E>
extends List<E>
{
	/**
	 * Hinzufgen aller Elemente aus dem bergebenen {@link Iterable}.
	 * 
	 * @param itbl hinzuzufgende Elemente
	 * @return see {@link List#addAll}
	 */
	boolean addAll( Iterable<? extends E> itbl );

	/**
	 * Hinzufgen aller Elemente aus dem bergebenen {@link Iterable}.
	 * 
	 * @param itbl hinzuzufgende Elemente
	 * @return see {@link List#addAll}
	 */
	boolean addAll( SizeableIterable<? extends E> itbl );
}
