package de.heinerkuecker.asm_improved.util;

/**
 * String-Util-Methoden.
 * 
 * @author Heiner K&uuml;cker
 */
public class StringUtil
{

	/**
	 * Konstruktor private,
	 * Instanziieren verboten,
	 * Util-Klasse.
	 */
	private StringUtil()
	{
		super();
	}

	/**
	 * @param strToTest zu prfender String
	 * @return ob der zu prfende String <code>null</code> oder leer ({@link String#isEmpty}) ist
	 */
	public static boolean isNullOrEmpty(
			final String strToTest )
	{
		return
				strToTest == null ||
				strToTest.isEmpty();
	}

	/**
	 * @param strToTest zu prfender String
	 * @return ob der zu prfende String <code>null</code> oder leer ({@link String#isEmpty}) ist
	 */
	public static boolean isNullOrEmptyOrHasOnlyWhiteSpaces(
			final String strToTest )
	{
		return
				strToTest == null ||
				strToTest.isEmpty() ||
				hasOnlyWhiteSpaces( strToTest );
	}

	public static boolean hasOnlyWhiteSpaces(
			final String strToTest )
	{
		for ( int index = 0 ; index < strToTest.length() ; index++ )
		{
			if ( ! Character.isWhitespace( strToTest.charAt( index ) ) )
			{
				return false;
			}
		}
		return true;
	}

	public static String repeat(
			final String strToRepeat ,
			final int repeatCount )
	{
		final StringBuilder buff = new StringBuilder();

		for ( int count = repeatCount ; count > 0 ; count-- )
		{
			buff.append( strToRepeat );
		}
	
		return buff.toString();
	}

}
