package de.heinerkuecker.asm_improved;

import java.io.File;

import org.junit.Test;

/**
 * JUnit4-Testcase fr Test der Betriebsart {@link AsmClasspathInfo.Mode#EAGER}.
 * 
 * @author Heiner K&uuml;cker
 */
public class AllJavaHomeJarsModeEagerTest
{
	@Test
	public final void test()
	{
		final String javaHomePathStr = AllAsmTests.getJavaHomePathStr();

		testRecursiv(
				new File(
						javaHomePathStr ) );
	}
	
	private void testRecursiv(
			final File dir )
	{
		final File[] files = dir.listFiles();

		for ( final File file : files )
		{
			if ( file.isDirectory() )
			{
				testRecursiv( file );
			}
			else if ( file.getName().endsWith( ".jar" ) )
			{
				new AsmClasspathInfo(
						AsmClasspathInfo.Mode.EAGER ,
						file );
				
			}
		}
	}

}
