package de.heinerkuecker.asm_improved;

import java.io.File;

import de.heinerkuecker.asm_improved.annotation_use.AsmAnnotationUse;
import de.heinerkuecker.asm_improved.type.AsmClassType;
import de.heinerkuecker.asm_improved.type.generics.param.AsmAbstractTypeParam;
import de.heinerkuecker.asm_improved.util.Fqn;
import de.heinerkuecker.asm_improved.util.ImmutableArray;
import de.heinerkuecker.asm_improved.util.ImmutableMap;
import org.junit.Assert;

/**
 * Test-Assert-Vergleicher fuer {@link AsmClassInfo}.
 * 
 * @author Heiner K&uuml;cker
 */
public class AsmClassInfoAssertEqual
{
	/**
	 * TODO
	 */
	private AsmClassInfoAssertEqual()
	{
		// TODO Auto-generated constructor stub
	}

	public static void assertEqual(
			final AsmClassInfo obj ,
			//final File file ,
			final Fqn fqn ,
			final boolean isPrivate ,
			final boolean isProtected ,
			final boolean isPublic ,
			final boolean isAbstract ,
			final boolean isStatic ,
			final boolean isFinal ,
			final boolean isInterface ,
			final boolean isEnum ,
			final boolean isAnnotation ,
			//final boolean isTopLevel ,
			final boolean isInnerOrNested ,
			final ImmutableArray<? extends AsmAbstractTypeParam> typeParams ,
			final AsmClassType superType ,
			final ImmutableArray<? extends AsmClassType> interfaceTypes ,
			final ImmutableMap<String, ? extends AsmFieldInfo> fields ,
			final ImmutableMap<String, ? extends ImmutableArray<? extends AsmMethodInfo>> methods ,
					final String sourceFileName ,
					final ImmutableArray<? extends AsmAnnotationUse> annotations ,
					final Fqn enclosingClassFqn ,
					final String enclosingMethodName )
	{
		//Assert.assertEquals(
		//		"file" ,
		//		obj.file ,
		//		file );

		Assert.assertEquals(
				"fqn" ,
				obj.fqn ,
				fqn );

		Assert.assertEquals(
				"isPrivate" ,
				obj.isPrivate ,
				isPrivate );

		Assert.assertEquals(
				"isProtected" ,
				obj.isProtected ,
				isProtected );

		Assert.assertEquals(
				"isPublic" ,
				obj.isPublic ,
				isPublic );

		Assert.assertEquals(
				"isAbstract" ,
				obj.isAbstract ,
				isAbstract );

		Assert.assertEquals(
				"isStatic" ,
				obj.isStatic ,
				isStatic );

		Assert.assertEquals(
				"isFinal" ,
				obj.isFinal ,
				isFinal );

		Assert.assertEquals(
				"isInterface" ,
				obj.isInterface ,
				isInterface );

		Assert.assertEquals(
				"isEnum" ,
				obj.isEnum ,
				isEnum );

		Assert.assertEquals(
				"isAnnotation" ,
				obj.isAnnotation ,
				isAnnotation );

		//Assert.assertEquals(
		//		"isInnerOrNested" ,
		//		obj.isInnerOrNested ,
		//		isInnerOrNested );

		Assert.assertEquals(
				"typeParams" ,
				obj.typeParams ,
				typeParams );

		Assert.assertEquals(
				"superType" ,
				obj.superType ,
				superType );

		Assert.assertEquals(
				"interfaceTypes" ,
				obj.interfaceTypes ,
				interfaceTypes );

		Assert.assertEquals(
				"fields" ,
				obj.fields ,
				fields );

		Assert.assertEquals(
				"methods" ,
				obj.methods ,
				methods );

		Assert.assertEquals(
				"sourceFileName" ,
				obj.sourceFileName ,
				sourceFileName );

		Assert.assertEquals(
				"annotations" ,
				obj.annotations ,
				annotations );

		Assert.assertEquals(
				"enclosingClassFqn" ,
				obj.enclosingClassFqn ,
				enclosingClassFqn );

		Assert.assertEquals(
				"enclosingMethodName" ,
				obj.enclosingMethodName ,
				enclosingMethodName );
	}

}
