package de.heinerkuecker.asm_improved;

import org.junit.Assert;
import org.junit.Test;

import de.heinerkuecker.asm_improved.test_data.MultiNestedClass;

/**
 * JUnit4-Testcase fr Test der Methode {@link AsmClasspathInfo#getClassInfoMandantory}.
 * 
 * @author Heiner K&uuml;cker
 */
public class AsmClasspathInfoRescanClassWithDollarSepNameTest
{

	@Test
	public final void testEagerMode()
	{
		final AsmClasspathInfo eagerAsmClasspathInfo =
				new AsmClasspathInfo(
						AsmClasspathInfo.Mode.EAGER ,
						AllAsmTests.RT_JAR_FILE ,
						AllAsmTests.BIN_DIR_FILE );

		Assert.assertNotNull( eagerAsmClasspathInfo );

		AllAsmTests.asmClasspathInfo.getClassInfoMandantory(
				MultiNestedClass.NestedClass0.NestedClass1.NestedClass2.NestedClass3.class
				// Name mit Punkten abgetrennt
				.getCanonicalName() );

		/*
		 * Beim Nachladen muss das AsmClasspathInfo-Objekt erkennen,
		 * dass die class-Datei mit einem anderen Namen nachgescannt
		 * wurde und nicht ambigious im Classpath existiert und somit
		 * keine IllegalStateException werfen.
		 */
		AllAsmTests.asmClasspathInfo.getClassInfoMandantory(
				MultiNestedClass.NestedClass0.NestedClass1.NestedClass2.NestedClass3.class
				// Name mit Dollar-Zeichen abgetrennt
				.getName() );
		
		//Assert.fail("Not yet implemented");
	}

	@Test
	public final void testLazyMode()
	{
		final AsmClasspathInfo lazyAsmClasspathInfo =
				new AsmClasspathInfo(
						AsmClasspathInfo.Mode.LAZY ,
						AllAsmTests.RT_JAR_FILE ,
						AllAsmTests.BIN_DIR_FILE );

		Assert.assertNotNull( lazyAsmClasspathInfo );

		AllAsmTests.asmClasspathInfo.getClassInfoMandantory(
				MultiNestedClass.NestedClass0.NestedClass1.NestedClass2.NestedClass3.class
				// Name mit Punkten abgetrennt
				.getCanonicalName() );

		/*
		 * Beim Nachladen muss das AsmClasspathInfo-Objekt erkennen,
		 * dass die class-Datei mit einem anderen Namen nachgescannt
		 * wurde und nicht ambigious im Classpath existiert und somit
		 * keine IllegalStateException werfen.
		 */
		AllAsmTests.asmClasspathInfo.getClassInfoMandantory(
				MultiNestedClass.NestedClass0.NestedClass1.NestedClass2.NestedClass3.class
				// Name mit Dollar-Zeichen abgetrennt
				.getName() );
		
		//Assert.fail("Not yet implemented");
	}

}
