package de.heinerkuecker.asm_improved;

import org.junit.Assert;
import org.junit.Test;

import de.heinerkuecker.asm_improved.AsmDescAndSignatureParserUtil;

/**
 * JUnit4-Testcase fr die Methode
 * {@link AsmDescAndSignatureParserUtil#getSemicolonPosUnderConsiderationGenerics}.
 * 
 * @author Heiner K&uuml;cker
 */
public class AsmDescriptionAndSignatureParserGetSemicolonPosUnderConsiderationGenericsMethodTest
{

	/**
	 * Test method for {@link AsmDescAndSignatureParserUtil#getSemicolonPosUnderConsiderationGenerics}.
	 */
	@Test
	public final void testGetSemicolonPosUnderConsiderationGenerics01()
	{
		String testStr =
				"(Ljava/util/Enumeration;)V";
		
		int result =
				AsmDescAndSignatureParserUtil.getTypeEndPos(
						//str
						testStr ,
						//startPos
						1 ,
						//primitivePossible
						true );

		Assert.assertEquals(
				//expected
				23 ,
				//actual
				result );

		Assert.assertEquals(
				//expected
				testStr.charAt( 23 ) ,
				//actual
				';' );

		testStr =
				"(Ljava/util/Enumeration<+Ljava/io/InputStream;>;)V";
		
		result =
				AsmDescAndSignatureParserUtil.getTypeEndPos(
						//str
						testStr ,
						//startPos
						1 ,
						//primitivePossible
						true );

		Assert.assertEquals(
				//expected
				47 ,
				//actual
				result );

		Assert.assertEquals(
				//expected
				testStr.charAt( 47 ) ,
				//actual
				';' );

		testStr =
				"(Ljava/util/Enumeration<+Ljava/util/Enumeration<+Ljava/io/InputStream;>;>;)V";
		
		result =
				AsmDescAndSignatureParserUtil.getTypeEndPos(
						//str
						testStr ,
						//startPos
						1 ,
						//primitivePossible
						true );

		Assert.assertEquals(
				//expected
				73 ,
				//actual
				result );

		Assert.assertEquals(
				//expected
				testStr.charAt( 73 ) ,
				//actual
				';' );

		//Assert.fail( "Not yet implemented" );
	}

}
