package de.heinerkuecker.asm_improved;

import java.util.Collections;
import java.util.HashMap;
import java.util.TreeMap;

import org.junit.Assert;
import org.junit.Test;

import de.heinerkuecker.asm_improved.asm_dom.AsmDomInnerClass;
import de.heinerkuecker.asm_improved.type.AsmClassType;
import de.heinerkuecker.asm_improved.type.generics.param.AsmExtendsTypeParam;

/**
 * JUnit4-Testcase fr die Methode
 * {@link de.heinerkuecker.asm_improved.AsmMethodDescAndSignatureParser#parseMethodDescriptionAndSignature}.
 * 
 * @author Heiner K&uuml;cker
 */
public class AsmDescriptionAndSignatureParserParseMethodTest
{

	/**
	 * Test method for {@link de.heinerkuecker.asm_improved.AsmMethodDescAndSignatureParser#parseMethodDescriptionAndSignature}.
	 */
	@Test
	public final void testParseMethodDescriptionAndSignature01()
	{
		final MethodTypeparamsAndReturnAndParamsAndExceptionsTuple result =
				AsmMethodDescAndSignatureParser.parseMethodDescriptionAndSignature(
						//desc
						"()Lde/heinerkuecker/parser/java8/test/_0a_statement/method/fluent/StatementMethodFluent_0;" ,
						//signature
						null ,
						// exceptions
						null ,
						// extendsTypeParamMap
						new HashMap<String, AsmExtendsTypeParam>() ,
						//classpathInfo
						null ,
						//innerClassFileNameToDotSeparatedNameMap
						new TreeMap<String, String>() ,
						//innerClasses
						new FilteredForNonStaticAndSortedForOuterNameLengthReverseAsmDomInnerClasses(
								Collections.<AsmDomInnerClass>emptyList() ) );

		Assert.assertEquals(
				//expected
				"de.heinerkuecker.parser.java8.test._0a_statement.method.fluent.StatementMethodFluent_0" ,
				//actual
				( (AsmClassType) result.returnType ).fqn.toFqnStr() );

		Assert.assertTrue(
				result.paramTypes == null || result.paramTypes.isEmpty() );

		//Assert.fail( "Not yet implemented" );
	}

}
