package de.heinerkuecker.asm_improved;

import static org.junit.Assert.*;

import java.io.File;

import org.junit.Assert;
import org.junit.Test;

import de.heinerkuecker.asm_improved.test_data.annotation_use.TestTypeAnnotationUse;

/**
 * JUnit4-Testcase fr die Klasse {@link AsmInnerClassTypeCorrector}.
 * 
 * @author Heiner K&uuml;cker
 */
public class AsmInnerClassTypeCorrectorTest
{

	/**
	 * Test method for {@link AsmInnerClassTypeCorrector#correctMemberClassType}.
	 */
	@Test
	public void testCorrectMemberClassType()
	{
		final AsmClasspathInfo asmClasspathInfo =
				new AsmClasspathInfo(
						AsmClasspathInfo.Mode.LAZY ,
						new File(
								"C:\\Program Files\\Java\\jdk1.8.0_102\\jre\\lib\\deploy.jar" ) );
		
		final AsmClassInfo classInfo =
				asmClasspathInfo.getClassInfoMandantory(
						"com.sun.deploy.security.DeployURLClassPath$UrlLoader$1$1" );

		Assert.assertEquals(
				//expected
				classInfo.fqn.packageName.value ,
				//actual
				"com.sun.deploy.security" );

		Assert.assertEquals(
				//expected
				classInfo.fqn.dottedName.toJavaName() ,
				//actual
				"DeployURLClassPath.UrlLoader.1.1" );

		Assert.assertFalse(
				classInfo.isTopLevel() );

		Assert.assertFalse(
				classInfo.isFinal );

		Assert.assertFalse(
				classInfo.isAbstract );

		Assert.assertFalse(
				classInfo.isStatic );

		Assert.assertFalse(
				classInfo.isInterface );

		Assert.assertFalse(
				classInfo.isEnum );

		Assert.assertFalse(
				classInfo.isAnnotation );

		//org.junit.Assert.fail("Not yet implemented");
	}

}
