package de.heinerkuecker.asm_improved;

import org.junit.Assert;

import de.heinerkuecker.asm_improved.annotation_use.AsmAnnotationUse;
import de.heinerkuecker.asm_improved.type.AsmClassType;
import de.heinerkuecker.asm_improved.util.Fqn;

/**
 * Util-Klasse fr Tests.
 * 
 * @author user
 */
public final class AsmTestUtil
{

	/**
	 * TODO
	 */
	private AsmTestUtil()
	{
		super();
	}

	/**
	 * Assert Klasse der bergebenen Annotation.
	 * 
	 * @param annotationToAssert
	 * @param expectedAnnotationClass
	 */
	public static void assertAnnotationClassFqn(
			final AsmAnnotationUse annotationToAssert ,
			final Class<?> expectedAnnotationClass )
	{
		Assert.assertEquals(
				// expected
				new AsmClassType(
						new Fqn(
								expectedAnnotationClass ) ) ,
				//actual
				annotationToAssert.annotationType );
	}

}
