package de.heinerkuecker.asm_improved;

import org.junit.Assert;
import org.junit.Test;

import de.heinerkuecker.asm_improved.type.AsmClassType;

/**
 * JUnit4-Testcase fr die Methode {@link AsmClassInfo#isAssignableFrom}.
 * 
 * @author Heiner K&uuml;cker
 */
public class ClassInfoIsAssignableFromTest
{
	/**
	 * Test method for {@link AsmClassInfo#isAssignableFrom}.
	 */
	@Test
	public final void testIsAssignableFromPositive()
	{
		Assert.assertTrue(
				AsmClassType.JAVA_LANG_OBJECT.isAssignableFrom(
						AsmClassType.JAVA_LANG_STRING ,
						AllAsmTests.asmClasspathInfo ) );
		//Assert.fail("Not yet implemented");
	}

	/**
	 * Test method for {@link AsmClassInfo#isAssignableFrom}.
	 */
	@Test
	public final void testIsAssignableFromNegative()
	{
		Assert.assertFalse(
				AsmClassType.JAVA_LANG_STRING.isAssignableFrom(
						AsmClassType.JAVA_LANG_OBJECT ,
						AllAsmTests.asmClasspathInfo ) );
		//Assert.fail("Not yet implemented");
	}

}
