package de.heinerkuecker.asm_improved;

import org.junit.Assert;
import org.junit.Test;

import de.heinerkuecker.asm_improved.util.Fqn;

/**
 * JUnit4-Testcase fr die Methode {@link AsmClassInfo#isSuperClassOrImplementedInterface}.
 * 
 * @author Heiner K&uuml;cker
 */
public class ClassInfoIsSuperClassOrImplementedInterfaceTest
{
	/**
	 * Test method for {@link AsmClassInfo#isSuperClassOrImplementedInterface}.
	 */
	@Test
	public final void testIsSuperClassOrImplementedInterface01()
	{
		final AsmClassInfo stringClassInfo =
				AllAsmTests.asmClasspathInfo.getClassInfoMandantory(
						java.lang.String.class.getCanonicalName() );

		Assert.assertTrue(
				stringClassInfo.isSuperClassOrImplementedInterface(
						//"java.lang.Object"
						Fqn.JAVA_LANG_OBJECT_FQN ,
						AllAsmTests.asmClasspathInfo ) );
	}

	/**
	 * Test method for {@link AsmClassInfo#isSuperClassOrImplementedInterface}.
	 */
	@Test
	public final void testIsSuperClassOrImplementedInterface02()
	{
		final AsmClassInfo stringClassInfo =
				AllAsmTests.asmClasspathInfo.getClassInfoMandantory(
						java.lang.String.class.getCanonicalName() );

		Assert.assertTrue(
				stringClassInfo.isSuperClassOrImplementedInterface(
						//"java.io.Serializable"
						new Fqn( java.io.Serializable.class ) ,
						AllAsmTests.asmClasspathInfo ) );
	}

	/**
	 * Test method for {@link AsmClassInfo#isSuperClassOrImplementedInterface}.
	 */
	@Test
	public final void testIsSuperClassOrImplementedInterface03()
	{
		final AsmClassInfo stringClassInfo =
				AllAsmTests.asmClasspathInfo.getClassInfoMandantory(
						java.lang.String.class.getCanonicalName() );

		Assert.assertTrue(
				stringClassInfo.isSuperClassOrImplementedInterface(
						//"java.lang.Comparable"
						new Fqn( java.lang.Comparable.class ) ,
						AllAsmTests.asmClasspathInfo ) );
	}

	/**
	 * Test method for {@link AsmClassInfo#isSuperClassOrImplementedInterface}.
	 */
	@Test
	public final void testIsSuperClassOrImplementedInterface04()
	{
		final AsmClassInfo stringClassInfo =
				AllAsmTests.asmClasspathInfo.getClassInfoMandantory(
						java.lang.String.class.getCanonicalName() );

		Assert.assertTrue(
				stringClassInfo.isSuperClassOrImplementedInterface(
						//"java.lang.CharSequence"
						new Fqn( java.lang.CharSequence.class ) ,
						AllAsmTests.asmClasspathInfo ) );
	}

	/**
	 * Test method for {@link AsmClassInfo#isSuperClassOrImplementedInterface}.
	 */
	@Test
	public final void testIsSuperClassOrImplementedInterface05()
	{
		final AsmClassInfo arrayListClassInfo =
				AllAsmTests.asmClasspathInfo.getClassInfoMandantory(
						java.util.ArrayList.class.getCanonicalName() );

		Assert.assertTrue(
				arrayListClassInfo.isSuperClassOrImplementedInterface(
						//"java.util.List"
						new Fqn( java.util.List.class ) ,
						AllAsmTests.asmClasspathInfo ) );
	}

	/**
	 * Test method for {@link AsmClassInfo#isSuperClassOrImplementedInterface}.
	 */
	@Test
	public final void testIsSuperClassOrImplementedInterface06()
	{
		final AsmClassInfo arrayListClassInfo =
				AllAsmTests.asmClasspathInfo.getClassInfoMandantory(
						java.util.ArrayList.class.getCanonicalName() );

		Assert.assertTrue(
				arrayListClassInfo.isSuperClassOrImplementedInterface(
						//"java.util.AbstractList"
						new Fqn( java.util.AbstractList.class ) ,
						AllAsmTests.asmClasspathInfo ) );
	}

	/**
	 * Test method for {@link AsmClassInfo#isSuperClassOrImplementedInterface}.
	 */
	@Test
	public final void testIsSuperClassOrImplementedInterface07()
	{
		final AsmClassInfo arrayListClassInfo =
				AllAsmTests.asmClasspathInfo.getClassInfoMandantory(
						java.util.ArrayList.class.getCanonicalName() );

		Assert.assertTrue(
				arrayListClassInfo.isSuperClassOrImplementedInterface(
						//"java.util.AbstractCollection"
						new Fqn( java.util.AbstractCollection.class ) ,
						AllAsmTests.asmClasspathInfo ) );
	}

	/**
	 * Test method for {@link AsmClassInfo#isSuperClassOrImplementedInterface}.
	 */
	@Test
	public final void testIsSuperClassOrImplementedInterface08()
	{
		final AsmClassInfo arrayListClassInfo =
				AllAsmTests.asmClasspathInfo.getClassInfoMandantory(
						java.util.ArrayList.class.getCanonicalName() );

		Assert.assertTrue(
				arrayListClassInfo.isSuperClassOrImplementedInterface(
						//"java.lang.Object"
						Fqn.JAVA_LANG_OBJECT_FQN ,
						AllAsmTests.asmClasspathInfo ) );
	}

	/**
	 * Test method for {@link AsmClassInfo#isSuperClassOrImplementedInterface}.
	 */
	@Test
	public final void testIsSuperClassOrImplementedInterface09()
	{
		final AsmClassInfo arrayListClassInfo =
				AllAsmTests.asmClasspathInfo.getClassInfoMandantory(
						java.util.ArrayList.class.getCanonicalName() );

		Assert.assertTrue(
				arrayListClassInfo.isSuperClassOrImplementedInterface(
						//"java.util.Collection"
						new Fqn( java.util.Collection.class ) ,
						AllAsmTests.asmClasspathInfo ) );
	}

	/**
	 * Test method for {@link AsmClassInfo#isSuperClassOrImplementedInterface}.
	 */
	@Test
	public final void testIsSuperClassOrImplementedInterface10()
	{
		final AsmClassInfo arrayListClassInfo =
				AllAsmTests.asmClasspathInfo.getClassInfoMandantory(
						java.util.ArrayList.class.getCanonicalName() );

		Assert.assertTrue(
				arrayListClassInfo.isSuperClassOrImplementedInterface(
						//"java.util.Collection"
						new Fqn( java.util.Collection.class ) ,
						AllAsmTests.asmClasspathInfo ) );
	}

	/**
	 * Test method for {@link AsmClassInfo#isSuperClassOrImplementedInterface}.
	 */
	@Test
	public final void testIsSuperClassOrImplementedInterface11()
	{
		final AsmClassInfo arrayListClassInfo =
				AllAsmTests.asmClasspathInfo.getClassInfoMandantory(
						java.util.ArrayList.class.getCanonicalName() );

		Assert.assertFalse(
				arrayListClassInfo.isSuperClassOrImplementedInterface(
						//"java.util.Map"
						new Fqn( java.util.Map.class ) ,
						AllAsmTests.asmClasspathInfo ) );
	}

	/**
	 * Test method for {@link AsmClassInfo#isSuperClassOrImplementedInterface}.
	 */
	@Test
	public final void testIsSuperClassOrImplementedInterface12()
	{
		final AsmClassInfo arrayListClassInfo =
				AllAsmTests.asmClasspathInfo.getClassInfoMandantory(
						java.util.ArrayList.class.getCanonicalName() );

		Assert.assertTrue(
				arrayListClassInfo.isSuperClassOrImplementedInterface(
						//"java.lang.Iterable"
						new Fqn( java.lang.Iterable.class ) ,
						AllAsmTests.asmClasspathInfo ) );
	}

}
