package de.heinerkuecker.asm_improved;

import org.junit.Assert;
import org.junit.Test;

import de.heinerkuecker.asm_improved.util.ImmutableMap;

/**
 * JUnit4-Testcase fr die Klasse {@link AsmFieldInfo}.
 * 
 * @author Heiner K&uuml;cker
 */
public class FieldInfoTest
{
	/**
	 * Test method for {@link de.heinerkuecker.asm_improved.AsmFieldInfo}.
	 */
	@Test
	public final void testFieldInfoJavaLangString()
	{
		final AsmClassInfo stringClassInfo =
				AllAsmTests.asmClasspathInfo.getClassInfoMandantory(
						java.lang.String.class.getCanonicalName() );

		final ImmutableMap<String, ? extends AsmFieldInfo> fields = stringClassInfo.fields;

		Assert.assertNotNull(
				fields );

		//for ( final Entry<String, FieldInfo> fieldEntry : fields.entrySet() )
		//{
		//	System.out.println( fieldEntry );
		//}

		Assert.assertTrue(
				fields.containsKey( "value" ) );

		final AsmFieldInfo valueField = fields.get( "value" );

		Assert.assertTrue(
				valueField.isPrivate );

		Assert.assertTrue(
				valueField.isFinal );

		Assert.assertFalse(
				valueField.isStatic );

		//Assert.fail("Not yet implemented");
	}

	/**
	 * Test method for {@link de.heinerkuecker.asm_improved.AsmFieldInfo}.
	 */
	@Test
	public final void testFieldInfoJavaUtilMapEntry()
	{
		final AsmClassInfo entryClassInfo =
				AllAsmTests.asmClasspathInfo.getClassInfoMandantory(
						java.util.Map.Entry.class.getCanonicalName() );

		final ImmutableMap<String, ? extends AsmFieldInfo> fields = entryClassInfo.fields;

		Assert.assertTrue(
				fields == null ||
				fields.isEmpty() );

		//Assert.fail("Not yet implemented");
	}

}
