package de.heinerkuecker.asm_improved;

import org.junit.Assert;
import org.junit.Test;

import de.heinerkuecker.asm_improved.annotation_use.AsmAnnotationUse;
import de.heinerkuecker.asm_improved.test_data.MethodAnnotations;
import de.heinerkuecker.asm_improved.type.AsmClassType;
import de.heinerkuecker.asm_improved.util.Fqn;
import de.heinerkuecker.asm_improved.util.ImmutableArray;
import de.heinerkuecker.asm_improved.util.ImmutableMap;

/**
 * JUnit4-Testcase fr Test der Klasse {@link MethodAnnotations}.
 * 
 * @author Heiner K&uuml;cker
 */
public class MethodAnnotationsTest
{
    /**
     * Test method for {@link MethodAnnotations}.
     */
    @Test
    public final void test()
    {
    	final AsmClassInfo classInfo =
    			AllAsmTests.asmClasspathInfo.getClassInfoMandantory(
    					MethodAnnotations.class.getCanonicalName() );

    	final ImmutableMap<String, ? extends ImmutableArray<? extends AsmMethodInfo>> methods =
    			classInfo.methods;

    	Assert.assertNotNull(
    			methods );

    	// TODO auch fr die anderen Methoden
    	Assert.assertTrue(
    			methods.containsKey( "hashCode" ) );

    	final ImmutableArray<? extends AsmMethodInfo> methodListWithSameName =
    			methods.get( "hashCode" );

    	Assert.assertEquals( 
    			//expected
    			1 ,
    			//actual
    			methodListWithSameName.size() );

    	final AsmMethodInfo methodInfo = methodListWithSameName.get( 0 );

    	Assert.assertEquals( 
    			//expected
    			1 ,
    			//actual
    			methodInfo.annotations.size() );

    	final AsmAnnotationUse annotation = methodInfo.annotations.get( 0 );

    	Assert.assertEquals( 
    			//expected
    			new AsmClassType( new Fqn( MethodAnnotations.Annotation.class ) ) ,
    			//actual
    			annotation.annotationType );

    	Assert.assertTrue(
    			annotation.values == null || annotation.values.isEmpty() );
    }    

}
