package de.heinerkuecker.asm_improved;

import org.junit.Assert;
import org.junit.Test;

import de.heinerkuecker.asm_improved.test_data.MethodWithNotGenericNestedException;
import de.heinerkuecker.asm_improved.type.AsmClassType;
import de.heinerkuecker.asm_improved.type.AsmType;
import de.heinerkuecker.asm_improved.util.Fqn;
import de.heinerkuecker.asm_improved.util.ImmutableArray;

/**
 * JUnit4-Testcase fr {@link MethodWithNotGenericNestedException}.
 * 
 * @author Heiner K&uuml;cker
 */
public class MethodWithNotGenericNestedExceptionTest
{

    /**
     * Test method for {@link de.heinerkuecker.asm_improved.test_data.MethodWithNotGenericNestedException#m()}.
     */
    @Test
    public void testM()
    {
        final AsmClassInfo methodWithGenericExceptionClassInfo =
                AllAsmTests.asmClasspathInfo.getClassInfoMandantory(
                        MethodWithNotGenericNestedException.class.getCanonicalName() );

        final ImmutableArray<? extends AsmMethodInfo> mMethodInfos =
                methodWithGenericExceptionClassInfo.methods.get(
                        "m" );

        Assert.assertEquals( 1 , mMethodInfos.size() );
        
        final AsmMethodInfo mMethodInfo = mMethodInfos.get( 0 );

        Assert.assertEquals(
                1 ,
                mMethodInfo.exceptions.size() );

        //System.out.println( mMethodInfo.exceptions.get( 0 ) );
        
        final AsmType exceptionType = mMethodInfo.exceptions.get( 0 );
        
        Assert.assertTrue(
                exceptionType instanceof AsmClassType );

        final AsmClassType exceptionClassType = (AsmClassType) exceptionType;

        Assert.assertEquals(
                //expected
                new Fqn( MethodWithNotGenericNestedException.NestedException.class ) ,
                //actual
                exceptionClassType.fqn );

        Assert.assertTrue(
                exceptionClassType.typeArgs == null || exceptionClassType.typeArgs.isEmpty() );
        
        //Assert.fail( "Not yet implemented" );
    }

}
