package de.heinerkuecker.asm_improved.test.annotation_use;

import org.junit.runner.RunWith;
import org.junit.runners.Suite;
import org.junit.runners.Suite.SuiteClasses;

import de.heinerkuecker.asm_improved.MethodAnnotationsTest;
import de.heinerkuecker.asm_improved.test_data.annotation_use.package_annotation_deprecated.PackageAnnotationDeprecatedTest;
import de.heinerkuecker.asm_improved.test_data.annotation_use.package_annotation_xmlschema.PackageAnnotationXmlschemaTest;
import de.heinerkuecker.asm_improved.test_data.annotation_use.package_annotation_xmlschemas.PackageAnnotationXmlschemasTest;
import de.heinerkuecker.asm_improved.type.AsmTypePathTest;
import de.heinerkuecker.asm_improved.type_params.inherit_reinforced_bound.ClassesWithTypeparamsInheritReinforcedBoundedTest;

/**
 * JUnit4-Testsuite fr die ASM-Improved-Lib.
 * 
 * @author Heiner K&uuml;cker
 */
@SuppressWarnings("deprecation")
@RunWith(Suite.class)
@SuiteClasses(
{
	AnnotationOrgJunitTestTest.class ,

	/*
	 * Package Annotations
	 */
	PackageAnnotationDeprecatedTest.class ,
	PackageAnnotationXmlschemaTest.class ,
	PackageAnnotationXmlschemasTest.class ,

	/*
	 * Annotation Annotations
	 */
	AnnotationAnnotatedInheritedTest.class ,
	AnnotationAnnotatedRetentionTest.class ,
	AnnotationAnnotatedTargetTest.class ,


	/*
	 * Class Annotations
	 */
	ClassAnnotationUseValues1BooleanTest.class ,
	ClassAnnotationUseValues1BooleanDefaultTest.class ,
	ClassAnnotationUseValues1BooleanNoNameTest.class ,

	ClassAnnotationUseValues1BooleanArrayTest.class ,
	ClassAnnotationUseValues1BooleanArrayEmptyTest.class ,



	ClassAnnotationUseValues1EnumTest.class ,
	ClassAnnotationUseValues1EnumDefaultTest.class ,
	ClassAnnotationUseValues1EnumNoNameTest.class ,

	ClassAnnotationUseValues1EnumArrayTest.class ,
	ClassAnnotationUseValues1EnumArrayEmptyTest.class ,




	ClassAnnotationUseDeepNestedTest.class ,
	ClassAnnotationUseDeepNestedArrayTest.class ,
	ClassAnnotationUseDeepNestedArraySingletonTest.class ,

	ClassAnnotationUseDeepNestedFinallyEnumArrayTest.class ,
	ClassAnnotationUseDeepNestedFinallyEnumTest.class ,

	ClassAnnotationUseDeepNestedValues2Test.class ,

	/*
	 * Field Annotations
	 */

	/*
	 * Method Annotations
	 */
	MethodAnnotationsTest.class ,
	MethodReturnAnnotationUseTest.class ,

	/*
	 * Method Parameter Annotations
	 */
	MethodParamAnnotationUseTest.class ,
	MethodParamAnnotationUse2Test.class ,
	MethodReturnAndParamAnnotationUseTest.class ,
	TypeAnnotationOnMethodParamArray1Test.class ,
	
	/*
	 * Method Return Annotations
	 */
	TypeAnnotationOnMethodReturnArray1Test.class ,

	/*
	 * Type Annotations 
	 */
	TypeAnnotationUseTest.class ,
	TypeAnnotationOnImplementsTypeargsTest.class ,
	TypeAnnotationOnMethodTypeparamsTest.class ,
	TypeAnnotationOnClassTypeparamWildcardTest.class ,
	TypeAnnotationOnFieldArray1Test.class ,
	TypeAnnotationOnFieldTypeargumentTest.class ,
	TypeAnnotationOnFieldArray0Test.class ,
	TypeAnnotationOnMethodTypeparamWildcardTest.class ,
	TypeAnnotationOnThrowsTest.class ,
	TypeAnnotationOnFieldTypeardWildcardTest.class ,
	TypeAnnotationOnSuperClassTypeargsTest.class ,
	TypeAnnotationOnSuperClassAndOnImplementsTypeargsTest.class ,
	TypeAnnotationOnFieldPrimitiveTest.class ,
	AnnotationUseWithLocalClassValueTest.class ,
	TypeAnnotationOnFieldInnerTypeTest.class ,
	AsmTypePathTest.class
}
)
public class AllAsmAnnotationUseTests
{
}
