package de.heinerkuecker.asm_improved.test.annotation_use;

import org.junit.Assert;
import org.junit.Test;

import de.heinerkuecker.asm_improved.AllAsmTests;
import de.heinerkuecker.asm_improved.AsmClassInfo;
import de.heinerkuecker.asm_improved.annotation_use.AsmAnnotationUse;
import de.heinerkuecker.asm_improved.annotation_use.AsmEnumValueUse;
import de.heinerkuecker.asm_improved.test_data.annotation_def.TestAnnotation;
import de.heinerkuecker.asm_improved.test_data.annotation_use.TestClassAnnotationUseValues1EnumArray;
import de.heinerkuecker.asm_improved.type.AsmClassType;
import de.heinerkuecker.asm_improved.util.Fqn;

/**
 * JUnit4-Testcase fr die Klasse {@link TestClassAnnotationUseValues1EnumArray}.
 * 
 * @author Heiner K&uuml;cker
 */
public final class ClassAnnotationUseValues1EnumArrayTest
{
	/**
	 * Test method for {@link TestAnnotation}.
	 */
	@Test
	public final void test()
	{
		final AsmClassInfo annotatedClassInfo =
				AllAsmTests.asmClasspathInfo.getClassInfoMandantory(
						TestClassAnnotationUseValues1EnumArray.class.getCanonicalName() );

		Assert.assertTrue(
				annotatedClassInfo.isTopLevel() );

		Assert.assertFalse(
				annotatedClassInfo.isFinal );

		Assert.assertFalse(
				annotatedClassInfo.isAbstract );

		Assert.assertTrue(
				annotatedClassInfo.isStatic );

		Assert.assertFalse(
				annotatedClassInfo.isInterface );

		Assert.assertFalse(
				annotatedClassInfo.isEnum );

		Assert.assertFalse(
				annotatedClassInfo.isAnnotation );

		// Klassen-Annotation
		Assert.assertNotNull(
				annotatedClassInfo.annotations );

		Assert.assertFalse(
				annotatedClassInfo.annotations.isEmpty() );

		Assert.assertEquals(
				1 ,
				annotatedClassInfo.annotations.size() );

		final AsmAnnotationUse annotation = annotatedClassInfo.annotations.get( 0 );

		Assert.assertEquals(
				new AsmClassType( new Fqn( TestClassAnnotationUseValues1EnumArray.AnnotationValues1Enum.class ) ) ,
				annotation.annotationType );

		Assert.assertFalse(
				annotation.values.isEmpty() );

		Assert.assertEquals(
				1 ,
				annotation.values.size() );

		final Object annotationValue = annotation.values.get( "enumArr" );

		Assert.assertNotNull(
				annotationValue );

		Assert.assertArrayEquals(
				new Object[]{
						new AsmEnumValueUse( new AsmClassType( new Fqn( TestClassAnnotationUseValues1EnumArray.AnnotationEnum.class ) ) , "A" ) ,
						new AsmEnumValueUse( new AsmClassType( new Fqn( TestClassAnnotationUseValues1EnumArray.AnnotationEnum.class ) ) , "B" ) ,
						new AsmEnumValueUse( new AsmClassType( new Fqn( TestClassAnnotationUseValues1EnumArray.AnnotationEnum.class ) ) , "C" ) ,
				} ,
				(Object[]) annotationValue );
	}

}
