package de.heinerkuecker.asm_improved.test.annotation_use;

import org.junit.Assert;
import org.junit.Test;

import de.heinerkuecker.asm_improved.AllAsmTests;
import de.heinerkuecker.asm_improved.AsmClassInfo;
import de.heinerkuecker.asm_improved.annotation_use.AsmAnnotationUse;
import de.heinerkuecker.asm_improved.annotation_use.AsmEnumValueUse;
import de.heinerkuecker.asm_improved.test_data.annotation_def.TestAnnotation;
import de.heinerkuecker.asm_improved.test_data.annotation_use.TestClassAnnotationUseValues1Enum;
import de.heinerkuecker.asm_improved.type.AsmClassType;
import de.heinerkuecker.asm_improved.util.Fqn;

/**
 * JUnit4-Testcase fr die Klasse {@link TestClassAnnotationUseValues1Enum}.
 * 
 * @author Heiner K&uuml;cker
 */
public final class ClassAnnotationUseValues1EnumTest
{
	/**
	 * Test method for {@link TestAnnotation}.
	 */
	@Test
	public final void test()
	{
		final AsmClassInfo annotatedClassInfo =
				AllAsmTests.asmClasspathInfo.getClassInfoMandantory(
						TestClassAnnotationUseValues1Enum.class.getCanonicalName() );

		Assert.assertTrue(
				annotatedClassInfo.isTopLevel() );

		Assert.assertFalse(
				annotatedClassInfo.isFinal );

		Assert.assertFalse(
				annotatedClassInfo.isAbstract );

		Assert.assertTrue(
				annotatedClassInfo.isStatic );

		Assert.assertFalse(
				annotatedClassInfo.isInterface );

		Assert.assertFalse(
				annotatedClassInfo.isEnum );

		Assert.assertFalse(
				annotatedClassInfo.isAnnotation );

		// Klassen-Annotation
		Assert.assertNotNull(
				annotatedClassInfo.annotations );

		Assert.assertFalse(
				annotatedClassInfo.annotations.isEmpty() );

		Assert.assertEquals(
				1 ,
				annotatedClassInfo.annotations.size() );

		final AsmAnnotationUse annotation = annotatedClassInfo.annotations.get( 0 );

		Assert.assertEquals(
				new AsmClassType( new Fqn( TestClassAnnotationUseValues1Enum.AnnotationValues1Enum.class ) ) ,
				annotation.annotationType );

		Assert.assertFalse(
				annotation.values.isEmpty() );

		Assert.assertEquals(
				1 ,
				annotation.values.size() );

		final Object annotationValue = annotation.values.get( "value0" );

		Assert.assertNotNull(
				annotationValue );

		Assert.assertEquals(
				new AsmClassType( new Fqn( TestClassAnnotationUseValues1Enum.AnnotationEnum.class ) ) ,
				( (AsmEnumValueUse) annotationValue ).enumType );

		Assert.assertEquals(
				"A" ,
				( (AsmEnumValueUse) annotationValue ).enumValueName );
	}

}
