package de.heinerkuecker.asm_improved.test.annotation_use;

import org.junit.Assert;
import org.junit.Test;

import de.heinerkuecker.asm_improved.AllAsmTests;
import de.heinerkuecker.asm_improved.AsmClassInfo;
import de.heinerkuecker.asm_improved.AsmMethodInfo;
import de.heinerkuecker.asm_improved.AsmMethodParamInfo;
import de.heinerkuecker.asm_improved.annotation_use.AsmAnnotationUse;
import de.heinerkuecker.asm_improved.test_data.annotation_def.NotNull;
import de.heinerkuecker.asm_improved.test_data.annotation_def.ParamAnnotationWithStringValue;
import de.heinerkuecker.asm_improved.test_data.annotation_def.TestAnnotation;
import de.heinerkuecker.asm_improved.test_data.annotation_use.TestMethodParamAnnotation;
import de.heinerkuecker.asm_improved.test_data.annotation_use.TestMethodParamAnnotation2;
import de.heinerkuecker.asm_improved.util.Fqn;
import de.heinerkuecker.asm_improved.util.ImmutableArray;

/**
 * JUnit4-Testcase fr die Klasse {@link TestMethodParamAnnotation}.
 * 
 * @author Heiner K&uuml;cker
 */
public final class MethodParamAnnotationUse2Test
{
	/**
	 * Test method for {@link TestAnnotation}.
	 */
	@Test
	public final void test()
	{
		final AsmClassInfo annotatedClassInfo =
				AllAsmTests.asmClasspathInfo.getClassInfoMandantory(
						TestMethodParamAnnotation2.class.getCanonicalName() );

		final ImmutableArray<? extends AsmMethodInfo> methods =
				annotatedClassInfo.methods.get(
						"method" );

		Assert.assertEquals(
				//expected
				1 ,
				//actual
				methods.size() );

		final AsmMethodInfo methodInfo = methods.get( 0 );

		Assert.assertEquals(
				//expected
				1 , 
				//actual
				methodInfo.params.size() );
		
		final AsmMethodParamInfo methodParamInfo = methodInfo.params.get( 0 );

		Assert.assertEquals(
				//expected
				1 , 
				//actual
				methodParamInfo.annotations.size() );

		//{
		// TODO dies galt noch als an der Annotation @NotNull Target ElementType.PARAMETER stand
		//	final AsmAnnotationUse annotation0 = methodParamInfo.annotations.get( 0 );
		//
		//	Assert.assertEquals(
		//			//expected
		//			new Fqn( NotNull.class ) , 
		//			//actual
		//			annotation0.annotationType.fqn );
		//
		//	Assert.assertTrue(
		//			annotation0.annotationType.typeArgs == null || annotation0.annotationType.typeArgs.size() == 0 );
		//
		//	Assert.assertTrue(
		//			annotation0.values == null || annotation0.values.size() == 0 );
		//}

		{
			final AsmAnnotationUse annotation1 = methodParamInfo.annotations.get( 0 );

			Assert.assertEquals(
					//expected
					new Fqn( ParamAnnotationWithStringValue.class ) , 
					//actual
					annotation1.annotationType.fqn );

			Assert.assertTrue(
					annotation1.annotationType.typeArgs == null || annotation1.annotationType.typeArgs.size() == 0 );

			Assert.assertEquals(
					//expected
					1 , 
					//actual
					annotation1.values.size() );

			Assert.assertTrue(
					annotation1.values.containsKey( "value" ) );
			
			final Object annotationValue = annotation1.values.get( "value" );
			
			Assert.assertEquals(
					//expected
					"parameter" , 
					//actual
					annotationValue );
		}

		Assert.assertEquals(
				//expected
				1 , 
				//actual
				methodParamInfo.type.typeAnnotations.size() );

		{
			final AsmAnnotationUse annotation0 = methodParamInfo.type.typeAnnotations.get( 0 );

			Assert.assertEquals(
					//expected
					new Fqn( NotNull.class ) , 
					//actual
					annotation0.annotationType.fqn );

			Assert.assertTrue(
					annotation0.annotationType.typeArgs == null || annotation0.annotationType.typeArgs.size() == 0 );

			Assert.assertTrue(
					annotation0.values == null || annotation0.values.size() == 0 );
		}

		//Assert.fail( "nicht fertig" );
	}

}
