package de.heinerkuecker.asm_improved.test.annotation_use;

import org.junit.Assert;
import org.junit.Test;

import de.heinerkuecker.asm_improved.AllAsmTests;
import de.heinerkuecker.asm_improved.AsmClassInfo;
import de.heinerkuecker.asm_improved.AsmMethodInfo;
import de.heinerkuecker.asm_improved.AsmMethodParamInfo;
import de.heinerkuecker.asm_improved.annotation_use.AsmAnnotationUse;
import de.heinerkuecker.asm_improved.test_data.annotation_def.TestAnnotation;
import de.heinerkuecker.asm_improved.test_data.annotation_use.TestMethodReturnAnnotation;
import de.heinerkuecker.asm_improved.type.AsmClassType;
import de.heinerkuecker.asm_improved.type.AsmType;
import de.heinerkuecker.asm_improved.util.Fqn;
import de.heinerkuecker.asm_improved.util.ImmutableArray;

/**
 * JUnit4-Testcase fr die Klasse {@link TestMethodReturnAnnotation}.
 * 
 * @author Heiner K&uuml;cker
 */
public final class MethodReturnAnnotationUseTest
{
	/**
	 * Test method for {@link TestAnnotation}.
	 */
	@Test
	public final void test()
	{
		final AsmClassInfo classInfo =
				AllAsmTests.asmClasspathInfo.getClassInfoMandantory(
						TestMethodReturnAnnotation.class.getCanonicalName() );

		final ImmutableArray<? extends AsmMethodInfo> methods =
				classInfo.methods.get(
						"method" );

		Assert.assertEquals(
				//expected
				1 ,
				//actual
				methods.size() );

		final AsmMethodInfo method = methods.get( 0 );

		Assert.assertTrue(
				method.annotations == null || method.annotations.isEmpty() );

		//Assert.assertEquals(
		//		//expected
		//		1 ,
		//		//actual
		//		method.annotations.size() );
		//
		//final AsmAnnotationUse annotation = method.annotations.get( 0 );
		//
		//Assert.assertEquals(
		//		//expected
		//		new AsmClassType( new Fqn( de.heinerkuecker.asm_improved.test_data.annotation_def.NotNull.class ) ) ,
		//		//actual
		//		annotation.annotationType );

		{
		final AsmType returnType = method.returnType;

		Assert.assertEquals(
				//expected
				1 ,
				//actual
				returnType.typeAnnotations.size() );

		final AsmAnnotationUse typeAnnotation = returnType.typeAnnotations.get( 0 );

		Assert.assertEquals(
				//expected
				new AsmClassType( new Fqn( de.heinerkuecker.asm_improved.test_data.annotation_def.NotNull.class ) ) ,
				//actual
				typeAnnotation.annotationType );
		}

		{
		Assert.assertEquals(
				//expected
				1 ,
				//actual
				method.params.size() );

		final AsmMethodParamInfo param = method.params.get( 0 );

		Assert.assertTrue(
				param.annotations == null || param.annotations.size() == 0 );
		}

		//Assert.fail( "nicht fertig" );
	}

}
