/*
 * When here in eclipse the compile error
 * 
 * 	Inconsistent classfile encountered
 * 
 * raised, then build project with
 * 
 * Eclipse window menu -> Project -> Clean
 */
package de.heinerkuecker.asm_improved.test.inner_class.with_typeparams.field;

import java.util.HashMap;
import java.util.Map;

import org.junit.Assert;
import org.junit.Test;

import de.heinerkuecker.asm_improved.AllAsmTests;
import de.heinerkuecker.asm_improved.AsmClassInfo;
import de.heinerkuecker.asm_improved.AsmFieldInfo;
import de.heinerkuecker.asm_improved.type.AsmClassType;
import de.heinerkuecker.asm_improved.type.AsmType;
import de.heinerkuecker.asm_improved.type.generics.var.AsmTypevar;
import de.heinerkuecker.asm_improved.type.member.AsmInnerClassType;
import de.heinerkuecker.asm_improved.util.DottedName;
import de.heinerkuecker.asm_improved.util.Fqn;
import de.heinerkuecker.asm_improved.util.ImmutableArray;
import de.heinerkuecker.asm_improved.util.ImmutableMap;
import de.heinerkuecker.asm_improved.util.PackageName;

/**
 * JUnit4-Testcase fr {@link InnerClassWithTypeparamFieldUsing2}.
 * 
 * @author Heiner K&uuml;cker
 */
public class InnerClassTypeparamFieldUsing2Test
{
	@Test
	public final void testInnerClassWithTypeparamFieldUsing2()
	{
		final AsmClassInfo outerClassInfo =
				AllAsmTests.asmClasspathInfo.getClassInfoMandantory(
						InnerClassWithTypeparamFieldUsing2.class.getCanonicalName() );

		/*
		 * Type params
		 */
		Assert.assertEquals(
				//expected
				2 ,
				//actual
				outerClassInfo.typeParams.size() );

		final AsmClassInfo innerClassInfo =
				AllAsmTests.asmClasspathInfo.getClassInfoMandantory(
						InnerClassWithTypeparamFieldUsing2.Inner.class.getCanonicalName() );

		/*
		 * Type params
		 */
		Assert.assertEquals(
				//expected
				2 ,
				//actual
				innerClassInfo.typeParams.size() );

		/*
		 * Fields
		 */
		{
			final AsmFieldInfo fieldTypevarTypevarIntgrShortInfo =
					outerClassInfo.fields.get(
							"fieldTypevarTypevarIntgrShort" );

			Assert.assertEquals(
					//expected
					"de.heinerkuecker.asm_improved.test.inner_class.with_typeparams.field.InnerClassWithTypeparamFieldUsing2<T1, T2>.Inner<java.lang.Integer, java.lang.Short>" ,
					//actual
					fieldTypevarTypevarIntgrShortInfo.type.toJavaString() );

			Assert.assertTrue(
					fieldTypevarTypevarIntgrShortInfo.type instanceof AsmInnerClassType );

			final AsmInnerClassType fieldTypevarTypevarIntgrShortType = (AsmInnerClassType) fieldTypevarTypevarIntgrShortInfo.type;

			Assert.assertEquals(
					//expected
					"Inner" ,
					//actual
					fieldTypevarTypevarIntgrShortType.relativName./*simpleName()*/toString() );

			{
				final Map<String, AsmType> expectedMap = new HashMap<>();
				expectedMap.put( "T1" , AsmClassType.JAVA_LANG_INTEGER );
				expectedMap.put( "T2" , AsmClassType.JAVA_LANG_SHORT );

				Assert.assertEquals(
						//expected
						ImmutableMap.create(
								expectedMap ) ,
						//actual
						fieldTypevarTypevarIntgrShortType.getEntireTypeArgs( AllAsmTests.asmClasspathInfo ) );
			}

			{
				final Map<String, AsmType> expectedMap = new HashMap<>();
				expectedMap.put( "T1" , new AsmTypevar( "T1" ) );
				expectedMap.put( "T2" , new AsmTypevar( "T2" ) );

				Assert.assertEquals(
						//expected
						ImmutableMap.create(
								expectedMap ) ,
						//actual
						fieldTypevarTypevarIntgrShortType.outerOrEnclosingType.getEntireTypeArgs( AllAsmTests.asmClasspathInfo ) );
			}

			Assert.assertEquals(
					//expected
					new AsmInnerClassType(
							//outerOrEnclosingType
							new AsmClassType(
									new Fqn(
											new PackageName( "de.heinerkuecker.asm_improved.test.inner_class.with_typeparams.field" ) ,
											DottedName.valueOfNoDotSeparatedStr( "InnerClassWithTypeparamFieldUsing2" ) ) ,
									//typeArgs
									ImmutableArray.create(
											new AsmTypevar( "T1" ) ,
											new AsmTypevar( "T2" ) ) ) ,
							//relativName
							//DottedName.valueOfNoDotSeparatedStr(
							//new JavaIdentifier(
							"Inner" ,
							//typeArgs
							ImmutableArray.create(
									AsmClassType.JAVA_LANG_INTEGER ,
									AsmClassType.JAVA_LANG_SHORT ) ) ,
					//actual
					fieldTypevarTypevarIntgrShortType );
		}

		{
			final AsmFieldInfo fieldStrStringLongIntgrShortInfo =
					outerClassInfo.fields.get(
							"fieldStrStringLongIntgrShort" );

			Assert.assertEquals(
					//expected
					"de.heinerkuecker.asm_improved.test.inner_class.with_typeparams.field.InnerClassWithTypeparamFieldUsing2<java.lang.String, java.lang.Long>.Inner<java.lang.Integer, java.lang.Short>" ,
					//actual
					fieldStrStringLongIntgrShortInfo.type.toJavaString() );

			Assert.assertTrue(
					fieldStrStringLongIntgrShortInfo.type instanceof AsmInnerClassType );

			final AsmInnerClassType fieldStrStringLongIntgrShortType = (AsmInnerClassType) fieldStrStringLongIntgrShortInfo.type;

			Assert.assertEquals(
					//expected
					"Inner" ,
					//actual
					fieldStrStringLongIntgrShortType.relativName./*simpleName()*/toString() );

			{
				final Map<String, AsmType> expectedMap = new HashMap<>();
				expectedMap.put( "T1" , AsmClassType.JAVA_LANG_INTEGER );
				expectedMap.put( "T2" , AsmClassType.JAVA_LANG_SHORT );

				Assert.assertEquals(
						//expected
						ImmutableMap.create(
								expectedMap ) ,
						//actual
						fieldStrStringLongIntgrShortType.getEntireTypeArgs( AllAsmTests.asmClasspathInfo ) );
			}

			{
				final Map<String, AsmType> expectedMap = new HashMap<>();
				expectedMap.put( "T1" , AsmClassType.JAVA_LANG_STRING );
				expectedMap.put( "T2" , AsmClassType.JAVA_LANG_LONG );

				Assert.assertEquals(
						//expected
						ImmutableMap.create(
								expectedMap ) ,
						//actual
						fieldStrStringLongIntgrShortType.outerOrEnclosingType.getEntireTypeArgs( AllAsmTests.asmClasspathInfo ) );
			}


			Assert.assertEquals(
					//expected
					new AsmInnerClassType(
							//outerOrEnclosingType
							new AsmClassType(
									new Fqn(
											new PackageName( "de.heinerkuecker.asm_improved.test.inner_class.with_typeparams.field" ) ,
											DottedName.valueOfNoDotSeparatedStr( "InnerClassWithTypeparamFieldUsing2" ) ) ,
									//typeArgs
									ImmutableArray.create(
											AsmClassType.JAVA_LANG_STRING ,
											AsmClassType.JAVA_LANG_LONG ) ) ,
							//relativName
							//DottedName.valueOfNoDotSeparatedStr(
							//new JavaIdentifier(
							"Inner" ,
							//typeArgs
							ImmutableArray.create(
									AsmClassType.JAVA_LANG_INTEGER ,
									AsmClassType.JAVA_LANG_SHORT ) ) ,
					//actual
					fieldStrStringLongIntgrShortType );
		}

		//Assert.fail( "Not yet implemented" );

		/*
		{
			final AsmExtendsTypeParam typeParam0 = (AsmExtendsTypeParam) classInfo.typeParams.get( 0 );

			Assert.assertEquals(
					//expected
					"T" ,
					//actual
					typeParam0.name );

			final AsmIntersectionBound intersectionBound0 = (AsmIntersectionBound) typeParam0.boundType;

			Assert.assertEquals(
					//expected
					3 ,
					//actual
					intersectionBound0.boundTypes.size() );

			{
				final AsmClassType intersectionBound0Type = (AsmClassType) intersectionBound0.boundTypes.get( 0 );

				Assert.assertEquals(
						//expected
						new Fqn( de.heinerkuecker.asm_improved.test_data.MultiInnerClassWithTypeparams.class ) ,
						//actual
						intersectionBound0Type.fqn );

				Assert.assertEquals(
						//expected
						1 ,
						//actual
						intersectionBound0Type.typeArgs.size() );

				final AsmClassType intersectionBound0TypeTypearg = (AsmClassType) intersectionBound0Type.typeArgs.get( 0 );

				Assert.assertEquals(
						//expected
						Fqn.JAVA_LANG_STRING_FQN ,
						//actual
						intersectionBound0TypeTypearg.fqn );
			}

			{
				final AsmClassType intersectionBound1Type = (AsmClassType) intersectionBound0.boundTypes.get( 1 );

				Assert.assertEquals(
						//expected
						new Fqn( java.lang.Comparable.class ) ,
						//actual
						intersectionBound1Type.fqn );

				Assert.assertEquals(
						//expected
						1 ,
						//actual
						intersectionBound1Type.typeArgs.size() );

				final AsmClassType intersectionBound1TypeTypearg = (AsmClassType) intersectionBound1Type.typeArgs.get( 0 );

				Assert.assertEquals(
						//expected
						Fqn.JAVA_LANG_STRING_FQN ,
						//actual
						intersectionBound1TypeTypearg.fqn );
			}

			{
				final AsmClassType intersectionBound2Type = (AsmClassType) intersectionBound0.boundTypes.get( 2 );

				Assert.assertEquals(
						//expected
						new Fqn( java.io.Serializable.class ) ,
						//actual
						intersectionBound2Type.fqn );

				Assert.assertTrue(
						intersectionBound2Type.typeArgs == null || intersectionBound2Type.typeArgs.size() == 0 );
			}
		}

		{
			final AsmExtendsTypeParam typeParam1 = (AsmExtendsTypeParam) classInfo.typeParams.get( 1 );

			Assert.assertEquals(
					//expected
					"T1" ,
					//actual
					typeParam1.name );

			final AsmMemberClassType boundType = (AsmMemberClassType) typeParam1.boundType;

			Assert.assertEquals(
					//expected
					new Fqn( de.heinerkuecker.asm_improved.test_data.MultiInnerClassWithTypeparams.InnerClass0.class ) ,
					//actual
					boundType.getEntireFqn() );

			Assert.assertEquals(
					//expected
					1 ,
					//actual
					boundType.typeArgs.size() );

			final AsmClassType boundTypeTypearg = (AsmClassType) boundType.typeArgs.get( 0 );

			Assert.assertEquals(
					//expected
					Fqn.JAVA_LANG_DOUBLE_FQN ,
					//actual
					boundTypeTypearg.fqn );

			{
				final AsmClassType boundOuterOrEnclosingType = (AsmClassType) boundType.outerOrEnclosingType;

				Assert.assertEquals(
						//expected
						new Fqn( de.heinerkuecker.asm_improved.test_data.MultiInnerClassWithTypeparams.class ) ,
						//actual
						boundOuterOrEnclosingType.fqn );

				Assert.assertEquals(
						//expected
						1 ,
						//actual
						boundOuterOrEnclosingType.typeArgs.size() );

				final AsmClassType boundOuterOrEnclosingTypeTypearg = (AsmClassType) boundType.typeArgs.get( 0 );

				Assert.assertEquals(
						//expected
						Fqn.JAVA_LANG_DOUBLE_FQN ,
						//actual
						boundOuterOrEnclosingTypeTypearg.fqn );
			}
		}
		 */
		//Assert.fail( "Not yet implemented: restliche Typ-Parameter" );
		// TODO restliche Typ-Parameter

		/*
		 * Fields
		 */
		/*		
		Assert.assertEquals(
				//expected
				9 ,
				//actual
				classInfo.fields.size() );

		{
			final AsmFieldInfo fieldInfo =
					classInfo.fields.get(
							"field" );

			final AsmTypevar fieldTypevar = (AsmTypevar) fieldInfo.type;

			Assert.assertEquals(
					//expected
					"T" ,
					//actual
					fieldTypevar.name );
		}

		{
			final AsmFieldInfo fieldInfo =
					classInfo.fields.get(
							"innerClass0FieldDouble" );

			final AsmTypevar fieldTypevar = (AsmTypevar) fieldInfo.type;

			Assert.assertEquals(
					//expected
					"T1" ,
					//actual
					fieldTypevar.name );
		}

		{
			final AsmFieldInfo fieldInfo =
					classInfo.fields.get(
							"innerClass0RawField" );

			final AsmTypevar fieldTypevar = (AsmTypevar) fieldInfo.type;

			Assert.assertEquals(
					//expected
					"T2" ,
					//actual
					fieldTypevar.name );
		}

		{
			final AsmFieldInfo fieldInfo =
					classInfo.fields.get(
							"innerClass1RelativField" );

			final AsmMemberClassType fieldType = (AsmMemberClassType) fieldInfo.type;

			Assert.assertEquals(
					//expected
					new Fqn( de.heinerkuecker.asm_improved.test_data.MultiInnerClassWithTypeparams.InnerClass0.InnerClass1.class ) ,
					//actual
					fieldType.getEntireFqn() );

			Assert.assertEquals(
					//expected
					1 ,
					//actual
					fieldType.typeArgs.size() );

			AsmClassType fieldTypeTypearg = (AsmClassType) fieldType.typeArgs.get( 0 );

			Assert.assertEquals(
					//expected
					Fqn.JAVA_LANG_INTEGER_FQN ,
					//actual
					fieldTypeTypearg.fqn );

			{
				final AsmMemberClassType fieldOuterOrEnclosingType = (AsmMemberClassType) fieldType.outerOrEnclosingType;

				Assert.assertEquals(
						//expected
						new Fqn( de.heinerkuecker.asm_improved.test_data.MultiInnerClassWithTypeparams.InnerClass0.class ) ,
						//actual
						fieldOuterOrEnclosingType.getEntireFqn() );

				Assert.assertEquals(
						//expected
						1 ,
						//actual
						fieldOuterOrEnclosingType.typeArgs.size() );

				AsmClassType fieldOuterOrEnclosingTypeTypearg = (AsmClassType) fieldOuterOrEnclosingType.typeArgs.get( 0 );

				Assert.assertEquals(
						//expected
						Fqn.JAVA_LANG_DOUBLE_FQN ,
						//actual
						fieldOuterOrEnclosingTypeTypearg.fqn );

				{
					final AsmClassType fieldOuterOrEnclosingTypeOuterOrEnclosingType = (AsmClassType) fieldOuterOrEnclosingType.outerOrEnclosingType;

					Assert.assertEquals(
							//expected
							new Fqn( de.heinerkuecker.asm_improved.test_data.MultiInnerClassWithTypeparams.class ) ,
							//actual
							fieldOuterOrEnclosingTypeOuterOrEnclosingType.fqn );

					Assert.assertEquals(
							//expected
							1 ,
							//actual
							fieldOuterOrEnclosingTypeOuterOrEnclosingType.typeArgs.size() );

					AsmClassType fieldOuterOrEnclosingTypeOuterOrEnclosingTypeTypearg = (AsmClassType) fieldOuterOrEnclosingTypeOuterOrEnclosingType.typeArgs.get( 0 );

					Assert.assertEquals(
							//expected
							Fqn.JAVA_LANG_STRING_FQN ,
							//actual
							fieldOuterOrEnclosingTypeOuterOrEnclosingTypeTypearg.fqn );
				}
			}
		}

		{
			final AsmFieldInfo fieldInfo =
					classInfo.fields.get(
							"innerClass1RelativRawField" );

			final AsmClassType fieldType = (AsmClassType) fieldInfo.type;

			Assert.assertEquals(
					//expected
					new Fqn( de.heinerkuecker.asm_improved.test_data.MultiInnerClassWithTypeparams.InnerClass0.InnerClass1.class ) ,
					//actual
					fieldType.fqn );

			Assert.assertTrue(
					fieldType.typeArgs == null || fieldType.typeArgs.size() == 0 );
		}

		{
			final AsmFieldInfo fieldInfo =
					classInfo.fields.get(
							"innerClass2RelativField" );

			final AsmMemberClassType fieldType = (AsmMemberClassType) fieldInfo.type;

			Assert.assertEquals(
					//expected
					new Fqn( de.heinerkuecker.asm_improved.test_data.MultiInnerClassWithTypeparams.InnerClass0.InnerClass1.InnerClass2.class ) ,
					//actual
					fieldType.getEntireFqn() );

			Assert.assertEquals(
					//expected
					1 ,
					//actual
					fieldType.typeArgs.size() );

			AsmClassType fieldTypeTypearg = (AsmClassType) fieldType.typeArgs.get( 0 );

			Assert.assertEquals(
					//expected
					Fqn.JAVA_LANG_LONG_FQN ,
					//actual
					fieldTypeTypearg.fqn );

			{
				final AsmMemberClassType fieldOuterOrEnclosingType = (AsmMemberClassType) fieldType.outerOrEnclosingType;

				Assert.assertEquals(
						//expected
						new Fqn( de.heinerkuecker.asm_improved.test_data.MultiInnerClassWithTypeparams.InnerClass0.InnerClass1.class ) ,
						//actual
						fieldOuterOrEnclosingType.getEntireFqn() );

				Assert.assertEquals(
						//expected
						1 ,
						//actual
						fieldOuterOrEnclosingType.typeArgs.size() );

				AsmClassType fieldOuterOrEnclosingTypeTypearg = (AsmClassType) fieldOuterOrEnclosingType.typeArgs.get( 0 );

				Assert.assertEquals(
						//expected
						Fqn.JAVA_LANG_INTEGER_FQN ,
						//actual
						fieldOuterOrEnclosingTypeTypearg.fqn );

				{
					final AsmMemberClassType fieldOuterOrEnclosingTypeOuterOrEnclosingType = (AsmMemberClassType) fieldOuterOrEnclosingType.outerOrEnclosingType;

					Assert.assertEquals(
							//expected
							new Fqn( de.heinerkuecker.asm_improved.test_data.MultiInnerClassWithTypeparams.InnerClass0.class ) ,
							//actual
							fieldOuterOrEnclosingTypeOuterOrEnclosingType.getEntireFqn() );

					Assert.assertEquals(
							//expected
							1 ,
							//actual
							fieldOuterOrEnclosingTypeOuterOrEnclosingType.typeArgs.size() );

					AsmClassType fieldOuterOrEnclosingTypeOuterOrEnclosingTypeTypearg = (AsmClassType) fieldOuterOrEnclosingTypeOuterOrEnclosingType.typeArgs.get( 0 );

					Assert.assertEquals(
							//expected
							Fqn.JAVA_LANG_DOUBLE_FQN ,
							//actual
							fieldOuterOrEnclosingTypeOuterOrEnclosingTypeTypearg.fqn );

					{
						final AsmClassType fieldOuterOrEnclosingTypeOuterOrEnclosingTypeOuterOrEnclosingType = (AsmClassType) fieldOuterOrEnclosingTypeOuterOrEnclosingType.outerOrEnclosingType;

						Assert.assertEquals(
								//expected
								new Fqn( de.heinerkuecker.asm_improved.test_data.MultiInnerClassWithTypeparams.class ) ,
								//actual
								fieldOuterOrEnclosingTypeOuterOrEnclosingTypeOuterOrEnclosingType.getEntireFqn() );

						Assert.assertEquals(
								//expected
								1 ,
								//actual
								fieldOuterOrEnclosingTypeOuterOrEnclosingTypeOuterOrEnclosingType.typeArgs.size() );

						AsmClassType fieldOuterOrEnclosingTypeOuterOrEnclosingTypeOuterOrEnclosingTypeTypearg = (AsmClassType) fieldOuterOrEnclosingTypeOuterOrEnclosingTypeOuterOrEnclosingType.typeArgs.get( 0 );

						Assert.assertEquals(
								//expected
								Fqn.JAVA_LANG_STRING_FQN ,
								//actual
								fieldOuterOrEnclosingTypeOuterOrEnclosingTypeOuterOrEnclosingTypeTypearg.fqn );
					}
				}
			}
		}

		{
			final AsmFieldInfo fieldInfo =
					classInfo.fields.get(
							"innerClass2RelativRawField" );

			final AsmClassType fieldType = (AsmClassType) fieldInfo.type;

			Assert.assertEquals(
					//expected
					new Fqn( de.heinerkuecker.asm_improved.test_data.MultiInnerClassWithTypeparams.InnerClass0.InnerClass1.InnerClass2.class ) ,
					//actual
					fieldType.getEntireFqn() );

			Assert.assertTrue(
					fieldType.typeArgs == null || fieldType.typeArgs.size() == 0 );
		}

		{
			final AsmFieldInfo fieldInfo =
					classInfo.fields.get(
							"innerClass1Field" );

			final AsmTypevar fieldTypevar = (AsmTypevar) fieldInfo.type;

			Assert.assertEquals(
					//expected
					"T5" ,
					//actual
					fieldTypevar.name );
		}

		{
			final AsmFieldInfo fieldInfo =
					classInfo.fields.get(
							"innerClass0FieldWithTypevarTypearg" );

			final AsmTypevar fieldTypevar = (AsmTypevar) fieldInfo.type;

			Assert.assertEquals(
					//expected
					"T6" ,
					//actual
					fieldTypevar.name );
		}


/*		
		final FieldInfo fieldInfo =
				classInfo.fields.get(
						"innerClass0FieldDouble" );

		System.out.println( fieldInfo.type );
		System.out.println( fieldInfo.type.getClass() );

		//Assert.assertTrue( fieldInfo.type instanceof AsmMemberClassOfTypevar );
		//final AsmMemberClassOfTypevar memberClassOfTypevar = (AsmMemberClassOfTypevar) fieldInfo.type;
		//final AsmClassType memberClassOfTypevarClassType = memberClassOfTypevar.classType;
		//final AsmClassType memberClassOfTypevarClassType = (AsmClassType) fieldInfo.type;
		final AsmTypevar innerClass0FieldDoubleTypevar = (AsmTypevar) fieldInfo.type;
		AllAsmTests.asmClasspathInfo.getClassInfoMandantory(
				classInfo.getTypeParamMap().get( innerClass0FieldDoubleTypevar.name ) );



		Assert.assertEquals(
				//expected
				"de.heinerkuecker.asm_improved.test_data.MultiInnerClassWithTypeparams<java.lang.String>.InnerClass0<java.lang.Double>" ,
				//actual
				//memberClassOfTypevarClassType.toString()
				innerClass0FieldDoubleTypevar.);

		Assert.assertEquals(
				//expected
				new Fqn( de.heinerkuecker.asm_improved.test_data.MultiInnerClassWithTypeparams.InnerClass0.class ) ,
				//actual
				memberClassOfTypevarClassType.fqn );

		Assert.assertEquals(
				//expected
				1 ,
				//actual
				memberClassOfTypevarClassType.typeArgs.size() );

		Assert.assertEquals(
				//expected
				Fqn.JAVA_LANG_DOUBLE_FQN ,
				//actual
				( (AsmClassType) memberClassOfTypevarClassType.typeArgs.get( 0 ) ).fqn );
		 */
		//Assert.fail( "Not yet implemented: restliche Felder" );
	}

}
