package de.heinerkuecker.asm_improved.test.inner_class.with_typeparams.field;

/**
 * Outer class with type parameter.
 * 
 * @param <T1> type parameter
 * @param <T2> type parameter
 * @author Heiner K&uuml;cker
 */
public class InnerClassWithTypeparamFieldUsing2<T1, T2>
{
	/**
	 * Inner class (non static) with type parameter.
	 * 
	 * @param <T1> type parameter bewusst mit dem selben Namen wie der Type-Parameter der usseren Klasse (hiding) (Name gilt nur im Kontext einer Klasse)
	 * @param <T2> type parameter bewusst mit dem selben Namen wie der Type-Parameter der usseren Klasse (hiding) (Name gilt nur im Kontext einer Klasse)
	 */
	// hier werden die usseren Typ-Parameter T1 und T2 absichtlich gehided, sollte nie gemacht werden und gehrt durch den Compiler verboten
	public class Inner<T1, T2>
	{
		
	}

	/**
	 * Feld mit zwei Type-Variablen als Type-Argument zwei konkreten Typen als Type-Argumente verteilt ber ussere und innere Klasse.
	 */
	public InnerClassWithTypeparamFieldUsing2<T1, T2>.Inner<Integer, Short> fieldTypevarTypevarIntgrShort;

	/**
	 * Feld mit vier konkreten Typen als Type-Argumenten verteilt ber ussere und innere Klasse.
	 */
	public InnerClassWithTypeparamFieldUsing2<String, Long>.Inner<Integer, Short> fieldStrStringLongIntgrShort;

}
