package de.heinerkuecker.asm_improved.test_data.annotation_use;

import java.util.List;
import java.util.Map;

import de.heinerkuecker.asm_improved.test_data.annotation_def.TypeAnno0;
import de.heinerkuecker.asm_improved.test_data.annotation_def.TypeAnno1;
import de.heinerkuecker.asm_improved.test_data.annotation_def.TypeAnno2;
import de.heinerkuecker.asm_improved.test_data.annotation_def.TypeAnno3;
import de.heinerkuecker.asm_improved.test_data.annotation_def.TypeAnno4;
import de.heinerkuecker.asm_improved.test_data.annotation_def.TypeAnno5;
import de.heinerkuecker.asm_improved.test_data.annotation_def.TypeAnno6;

/**
 * Java file to parse.
 * 
 * Ziemliche seltsame Spezifikation:
 * <a href="https://docs.oracle.com/javase/specs/jls/se8/html/jls-9.html#jls-9.7.4">Java Language Specification - 9.7.4. Where Annotations May Appear </a>
 * in "@C int @A [] @B [] f; @A applies to the array type
 * int[][], @B applies to its component type int[], and @C
 * applies to the element type int."
 */
public class TestTypeAnnotationOnFieldArray1
{
	@TypeAnno0
	String [] strArr0 = null; //new @NotNull String @NotEmpty [ 0 ];

	String @TypeAnno1 [] strArr1 = null; //new @NotNull String @NotEmpty [ 0 ];

	@TypeAnno0
	String @TypeAnno1 [] strArr2 = null; //new @NotNull String @NotEmpty [ 0 ];

	@TypeAnno0
	String @TypeAnno1 [] @TypeAnno2 [] strArrArr = null; //new @NotNull String @NotNull [ 0 ] @NotNull [ 0 ];

	@TypeAnno0
	String @TypeAnno1 [] @TypeAnno2 [] @TypeAnno3 [] strArrArrArr = null; // new @NotNull String @NotNull [ 0 ] @NotNull [ 0 ] @NotNull [ 0 ];

	@TypeAnno0
	List< @TypeAnno1 String @TypeAnno2 [] @TypeAnno3 [] @TypeAnno4 [] > strArrArrArrList = null;

	@TypeAnno0
	Map< @TypeAnno1 String @TypeAnno2 [] @TypeAnno3 [] @TypeAnno4 [] , @TypeAnno1 String @TypeAnno2 [] @TypeAnno3 [] @TypeAnno4 [] > strArrArrArrMap = null;

	@TypeAnno0
	List<@TypeAnno2 String @TypeAnno3 [] @TypeAnno4 [] @TypeAnno5 []> @TypeAnno1 [] strArrArrArrListArr = null;

	@TypeAnno0
	List<@TypeAnno3 String @TypeAnno4 [] @TypeAnno5 [] @TypeAnno6 []> @TypeAnno1 [] @TypeAnno2 [] strArrArrArrListArrArr = null;

	@TypeAnno0
	Map<@TypeAnno2 String @TypeAnno3 [] @TypeAnno4 [] @TypeAnno5 [], @TypeAnno2 String @TypeAnno3 [] @TypeAnno4 [] @TypeAnno5 []> @TypeAnno1 [] strArrArrArrMapArr = null;

	@TypeAnno0
	Map<@TypeAnno3 String @TypeAnno4 [] @TypeAnno5 [] @TypeAnno6 [], @TypeAnno3 String @TypeAnno4 [] @TypeAnno5 [] @TypeAnno6 []> @TypeAnno1 [] @TypeAnno2 [] strArrArrArrMapArrArr = null;

	//@NotNull
	//String @NotNull [] @NotNull [] @NotNull [] strArrArrArr = new @NotNull String @NotNull [ 0 ] @NotNull [ 0 ] @NotNull [ 0 ];

	//@NotNull
	//String @NotNull [] @NotNull [] @NotNull [] strArrArrArrArr @NotNull [] = null;

	//@NotNull
	//String @NotNull [] @NotNull [] @NotNull [] strArrArrArrArrArr @NotNull [] @NotNull [] = null;

}
