package de.heinerkuecker.asm_improved.test_data.annotation_use;

import java.util.ArrayList;
import java.util.List;

import de.heinerkuecker.asm_improved.test_data.MultiInnerClass;
import de.heinerkuecker.asm_improved.test_data.annotation_def.NotEmpty;
import de.heinerkuecker.asm_improved.test_data.annotation_def.NotNull;

/**
 * Java file to parse.
 */
public class TestTypeAnnotationUse
{
	@NotNull
	List<@NotNull @NotEmpty String> strList = new ArrayList<>();

	@NotNull
	List<@NotNull List<@NotNull @NotEmpty String>> strListList = new ArrayList<>();

	/**
	 * Durch die Annotation vor dem Array-Typ wird scheinbar der Array-Typ insgesamt, nicht der Element-Typ des Arrays annotiert.
	 */
	@NotNull
	String[] strArr0;

	/**
	 * Durch die Array-Klammern nach dem Namen wird scheinbar nur der Element-Typ des Arrays annotiert, nicht der der Array-Typ insgesamt.
	 */
	@NotNull
	String strArr1[];

	MultiInnerClass.@NotNull InnerClass0 inner = null;

	List<? extends @NotNull String> extendsStrList = null;

	@NotNull
	String @NotNull [] @NotNull [] @NotNull [] strArrArrArr = null;

	@NotNull
	String @NotNull [] @NotNull [] @NotNull [] strArrArrArrArr @NotNull [] = null;

	@NotNull
	String @NotNull [] @NotNull [] @NotNull [] strArrArrArrArrArr @NotNull [] @NotNull [] = null;

	<T> void m(
			@NotNull T t )
	{
		
	}
	
	// TODO weitere Arten von Typen, an welche Typ-Annotationen geschrienben werden knnen, siehe org.objectweb.asm.TypePath: ARRAY_ELEMENT, INNER_TYPE, WILDCARD_BOUND, TYPE_ARGUMENT
}
