package de.heinerkuecker.asm_improved.type_param;

import java.io.Serializable;

import org.junit.Assert;
import org.junit.Test;

import de.heinerkuecker.asm_improved.AllAsmTests;
import de.heinerkuecker.asm_improved.AsmClasspathInfo;
import de.heinerkuecker.asm_improved.AsmClassInfo;
import de.heinerkuecker.asm_improved.type.AsmClassType;
import de.heinerkuecker.asm_improved.type.generics.param.AsmExtendsTypeParam;
import de.heinerkuecker.asm_improved.type.generics.param.AsmAbstractTypeParam;
import de.heinerkuecker.asm_improved.util.Fqn;

/**
 * JUnit4-Testcase fr {@link AsmClasspathInfo}.
 * 
 * @author Heiner K&uuml;cker
 */
public class ClassWithTypeparamBoundedTest
{

	@Test
	public final void test()
	{
		final AsmClassInfo classInfo =
				AllAsmTests.asmClasspathInfo.getClassInfoMandantory(
						ClassWithTypeparamBounded.class.getCanonicalName() );

		//System.out.println( classInfo.typeParams );

		Assert.assertEquals(
				//expected
				1 ,
				//actual
				classInfo.typeParams.size() );

		final AsmAbstractTypeParam typeParam0 =
				classInfo.typeParams.get( 0 );

		//System.out.println( typeParam0 );

		Assert.assertEquals(
				//expected
				"T" ,
				//actual
				typeParam0.name );

		Assert.assertTrue(
				typeParam0 instanceof AsmExtendsTypeParam );

		final AsmExtendsTypeParam extendsTypeParam0 = (AsmExtendsTypeParam) typeParam0;

		
		Assert.assertTrue(
				extendsTypeParam0.boundType instanceof AsmClassType );

		final AsmClassType boundType = (AsmClassType) extendsTypeParam0.boundType;

		Assert.assertEquals(
				//expected
				new Fqn( Serializable.class ) ,
				//actual
				boundType.fqn );

		//Assert.fail( "Not yet implemented" );
	}

}
