package de.heinerkuecker.asm_improved.type_param;

import org.junit.Assert;
import org.junit.Test;

import de.heinerkuecker.asm_improved.AllAsmTests;
import de.heinerkuecker.asm_improved.AsmClasspathInfo;
import de.heinerkuecker.asm_improved.AsmClassInfo;
import de.heinerkuecker.asm_improved.type.generics.param.AsmAbstractTypeParam;
import de.heinerkuecker.asm_improved.type.generics.param.AsmUnboundedTypeParam;

/**
 * JUnit4-Testcase fr {@link AsmClasspathInfo}.
 * 
 * @author Heiner K&uuml;cker
 */
public class ClassWithTypeparamUnboundedTest
{
	@SuppressWarnings("javadoc")
    @Test
	public final void testClassWithTypeparams()
	{
		final AsmClassInfo classInfo =
				AllAsmTests.asmClasspathInfo.getClassInfoMandantory(
						ClassWithTypeparamUnbounded.class.getCanonicalName() );

		//System.out.println( classInfo.typeParams );

		Assert.assertEquals(
				//expected
				1 ,
				//actual
				classInfo.typeParams.size() );

		final AsmAbstractTypeParam typeParam0 =
				classInfo.typeParams.get( 0 );

		//System.out.println( typeParam0 );

		Assert.assertEquals(
				//expected
				"T" ,
				//actual
				typeParam0.name );

		Assert.assertTrue(
				typeParam0 instanceof AsmUnboundedTypeParam );

		//Assert.fail( "Not yet implemented" );
	}

}
