package de.heinerkuecker.asm_improved.type_params;

import org.junit.Assert;
import org.junit.Test;

import de.heinerkuecker.asm_improved.AllAsmTests;
import de.heinerkuecker.asm_improved.AsmClasspathInfo;
import de.heinerkuecker.asm_improved.AsmClassInfo;
import de.heinerkuecker.asm_improved.type.generics.param.AsmAbstractTypeParam;
import de.heinerkuecker.asm_improved.type.generics.param.AsmUnboundedTypeParam;

/**
 * JUnit4-Testcase fr {@link AsmClasspathInfo}.
 * 
 * @author Heiner K&uuml;cker
 */
public class ClassWithTypeparamsUnboundedTest
{

	@Test
	public final void testClassWithTypeparams()
	{
		final AsmClassInfo classInfo =
				AllAsmTests.asmClasspathInfo.getClassInfoMandantory(
						ClassWithTypeparamsUnbounded.class.getCanonicalName() );

		//System.out.println( classInfo.typeParams );

		Assert.assertEquals(
				//expected
				2 ,
				//actual
				classInfo.typeParams.size() );

		{
			final AsmAbstractTypeParam typeParam0 =
					classInfo.typeParams.get( 0 );

			//System.out.println( typeParam0 );

			Assert.assertEquals(
					//expected
					"T0" ,
					//actual
					typeParam0.name );

			Assert.assertTrue(
					typeParam0 instanceof AsmUnboundedTypeParam );
		}

		{
			final AsmAbstractTypeParam typeParam1 =
					classInfo.typeParams.get( 1 );

			//System.out.println( typeParam1 );

			Assert.assertEquals(
					//expected
					"T1" ,
					//actual
					typeParam1.name );

			Assert.assertTrue(
					typeParam1 instanceof AsmUnboundedTypeParam );
		}

		//Assert.fail( "Not yet implemented" );
	}

}
