package de.heinerkuecker.asm_improved.type_params.inherit_reinforced_bound;

import java.util.Map;

/**
 * Test classes for {@link de.heinerkuecker.asm_improved.type.util.InheritTypeArgsUtil#getSuperClassesOrInterfaceInheritBoundReinforcedTypeArgMap}.
 */
public class ClassesWithTypeparamsInheritReinforcedBounded
{
	
	Map.Entry<Number, Number> numberEntry = null;

	/**
	 * {@link Map.Entry}-Implementierung mit Bound auf {@link Comparable}.
	 *
	 * @param <CK> type parameter comparable key
	 * @param <CV> type parameter comparable value
	 */
	abstract public static class ComparableEntry<CK extends Comparable<CK>, CV extends Comparable<CV>>
	implements Map.Entry<CK, CV>
	{
		// no implementation
	}

	// TODO klappt leider nicht: ComparableEntry<Number, Number> numberComparableEntry = null;
	
	/**
	 * {@link Map.Entry}-Implementierung mit Bound auf {@link Number}.
	 * 
	 * @param <NK> type parameter number key
	 * @param <NV> type parameter number value
	 */
	abstract public static class NumberEntry<NK extends Number &  Comparable<NK>, NV extends Number &  Comparable<NV>>
	extends ComparableEntry<NK, NV>
	{
		// no implementation
	}

	ComparableEntry<Integer, Integer> integerComparableEntry = null;
	
	/**
	 * {@link Map.Entry}-Implementierung mit Bound auf {@link Integer}.
	 * 
	 * @param <NK> type parameter number key
	 * @param <NV> type parameter number value
	 */
	abstract public static class IntegerComparableEntry
	extends ComparableEntry<Integer, Integer>
	{
		// no implementation
	}

	NumberEntry<Integer, Integer> integerNumberEntry = null;
	
	/**
	 * {@link Map.Entry}-Implementierung mit Bound auf {@link Integer}.
	 * 
	 * @param <NK> type parameter number key
	 * @param <NV> type parameter number value
	 */
	abstract public static class IntegerNumberEntry
	extends NumberEntry<Integer, Integer>
	{
		// no implementation
	}

	ComparableEntry<Long, Long> longComparableEntry = null;
	
	/**
	 * {@link Map.Entry}-Implementierung mit Bound auf {@link Long}.
	 * 
	 * @param <NK> type parameter number key
	 * @param <NV> type parameter number value
	 */
	abstract public static class LongComparableEntry
	extends ComparableEntry<Long, Long>
	{
		// no implementation
	}

	NumberEntry<Long, Long> longNumberEntry = null;
	
	/**
	 * {@link Map.Entry}-Implementierung mit Bound auf {@link Long}.
	 * 
	 * @param <NK> type parameter number key
	 * @param <NV> type parameter number value
	 */
	abstract public static class LongNumberEntry
	extends NumberEntry<Long, Long>
	{
		// no implementation
	}

	/*
	 * Wildcards
	 */

	NumberEntry<?, ?> wildcardNumberEntry = null;
	
	/**
	 * {@link Map.Entry}-Implementierung mit Bound auf Wildcard.
	 * 
	 * @param <NK> type parameter number key
	 * @param <NV> type parameter number value
	 */
	// TODO nicht moeglich
	//abstract public static class WildcardNumberEntry
	//extends NumberEntry<?, ?>
	//{
	//}

}
