/**
 * 
 */
package de.heinerkuecker.asm_improved.type_params.inherit_reinforced_bound;

import static org.junit.Assert.*;

import java.util.Map;

import org.junit.Assert;
import org.junit.Test;

import de.heinerkuecker.asm_improved.AllAsmTests;
import de.heinerkuecker.asm_improved.AsmClassInfo;
import de.heinerkuecker.asm_improved.AsmClasspathInfo;
import de.heinerkuecker.asm_improved.type.AsmClassType;
import de.heinerkuecker.asm_improved.type.AsmType;
import de.heinerkuecker.asm_improved.type.util.InheritTypeArgsUtil;
import de.heinerkuecker.asm_improved.type_params.ClassWithTypeparamsBounded;
import de.heinerkuecker.asm_improved.util.Fqn;
import de.heinerkuecker.asm_improved.util.ImmutableMap;

/**
 * JUnit4-Testcase fr {@link de.heinerkuecker.asm_improved.type.util.InheritTypeArgsUtil#getSuperClassesOrInterfaceInheritBoundReinforcedTypeArgMap}.
 * 
 * @author Heiner K&uuml;cker
 */
public class ClassesWithTypeparamsInheritReinforcedBoundedTest
{

	@Test
	public void testComparableEntryClass()
	{
		final AsmClassInfo classInfo =
				AllAsmTests.asmClasspathInfo.getClassInfoMandantory(
						de.heinerkuecker.asm_improved.type_params.inherit_reinforced_bound.ClassesWithTypeparamsInheritReinforcedBounded.ComparableEntry.class.getCanonicalName() );

		final AsmClassInfo mapEntryClassInfo =
				AllAsmTests.asmClasspathInfo.getClassInfoMandantory(
						Map.Entry.class.getCanonicalName() );

		final InheritTypeArgsUtil.SuperClassesOrInterfaceInheritBoundReinforcedTypeArgMapOption superClassesOrInterfaceInheritBoundReinforcedTypeArgMapOption =
				InheritTypeArgsUtil.getSuperClassesOrInterfaceInheritBoundReinforcedTypeArgMap(
						classInfo ,
						//inheritanceTypeArgs
						null ,
						mapEntryClassInfo ,
						AllAsmTests.asmClasspathInfo );

		Assert.assertTrue(
				superClassesOrInterfaceInheritBoundReinforcedTypeArgMapOption.isPresent() );

		final ImmutableMap<String, AsmType> superClassesOrInterfaceInheritBoundReinforcedTypeArgMap =
				superClassesOrInterfaceInheritBoundReinforcedTypeArgMapOption.getResult();

		Assert.assertEquals(
				//expected
				new AsmClassType(
						new Fqn( Comparable.class ) ,
						AsmClassType.JAVA_LANG_OBJECT ) ,
				//actual
				superClassesOrInterfaceInheritBoundReinforcedTypeArgMap.get( "K" ) );

		Assert.assertEquals(
				//expected
				new AsmClassType(
						new Fqn( Comparable.class ) ,
						AsmClassType.JAVA_LANG_OBJECT ) ,
				//actual
				superClassesOrInterfaceInheritBoundReinforcedTypeArgMap.get( "V" ) );
	}

	@Test
	public void testNumberEntryField()
	{
		final AsmClassInfo classInfo =
				AllAsmTests.asmClasspathInfo.getClassInfoMandantory(
						de.heinerkuecker.asm_improved.type_params.inherit_reinforced_bound.ClassesWithTypeparamsInheritReinforcedBounded.class.getCanonicalName() );

		final AsmClassType numberEntryFieldType = (AsmClassType) classInfo.fields.get( "numberEntry" ).type;

		final AsmClassInfo mapEntryClassInfo =
				AllAsmTests.asmClasspathInfo.getClassInfoMandantory(
						Map.Entry.class.getCanonicalName() );

		final InheritTypeArgsUtil.SuperClassesOrInterfaceInheritBoundReinforcedTypeArgMapOption superClassesOrInterfaceInheritBoundReinforcedTypeArgMapOption =
				InheritTypeArgsUtil.getSuperClassesOrInterfaceInheritBoundReinforcedTypeArgMap(
						AllAsmTests.asmClasspathInfo.getClassInfoMandantory( numberEntryFieldType.fqn ) ,
						//inheritanceTypeArgs
						numberEntryFieldType.getEntireTypeArgs( AllAsmTests.asmClasspathInfo ) ,
						mapEntryClassInfo ,
						AllAsmTests.asmClasspathInfo );

		Assert.assertTrue(
				superClassesOrInterfaceInheritBoundReinforcedTypeArgMapOption.isPresent() );

		final ImmutableMap<String, AsmType> superClassesOrInterfaceInheritBoundReinforcedTypeArgMap =
				superClassesOrInterfaceInheritBoundReinforcedTypeArgMapOption.getResult();

		Assert.assertEquals(
				//expected
				new AsmClassType(
						new Fqn( Number.class ) ) ,
				//actual
				superClassesOrInterfaceInheritBoundReinforcedTypeArgMap.get( "K" ) );

		Assert.assertEquals(
				//expected
				new AsmClassType(
						new Fqn( Number.class ) ) ,
				//actual
				superClassesOrInterfaceInheritBoundReinforcedTypeArgMap.get( "V" ) );
	}

	@Test
	public void testRest()
	{
		Assert.fail( "restliche Klassen und Felder aus ClassesWithTypeparamsInheritReinforcedBounded" );
	}

	
}
